
# ---------------------------------------------
# Set the Operating System you're building for
#----------------------------------------------
 OSTYPE = djgpp
# OSTYPE = mingw
# OSTYPE = linux

#------------------------------
# Compiler, Linker and Utility
#------------------------------
AR              = @ar
CC              = gcc
RC              = @windres
MD              = -mkdir
RM              = @rm -f
STRIP           = @strip
EXEDAT          = @exedat
EXEPACK         = @upx
DXE3GEN         = dxe3gen
DXE3RES         = dxe3res

#-------------
# Directories
#-------------
SRC_DIR         = src/bin
BIN_OBJ_DIR     = obj/$(OSTYPE)/bin
OBJS_DIR        = obj/$(OSTYPE)
OBJLIB_DIR      = $(OBJS_DIR)/objlib
#LIB             = $(OBJLIB_DIR)
LIB             = models
SRC_TAB         = src/dxetab

#-----------
# Libraries
#-----------
DEVICES  = bsim1 bsim2 csw jfet ltra mes sw tra urc bjt dio \
           mos1 mos2 mos3 mos6 asrc cap cccs ccvs ind isrc res \
           vccs vcvs vsrc \
           bsim3 bsim4

TABDEVSRC  = $(addprefix $(SRC_TAB)/t, $(addsuffix .c, $(DEVICES)))
TABDEVOBJ  = $(addprefix $(BIN_OBJ_DIR)/t, $(addsuffix .o, $(DEVICES)))
LIBDEV     = $(addprefix $(LIB)/, $(addsuffix .dxe, $(DEVICES)))

all: maketree $(LIBDEV) $(TABDEVSRC) $(TABDEVOBJ)

maketree: $(SRC_TAB)

$(SRC_TAB):
	$(MD) $(SRC_TAB)

$(LIB)/%.dxe: $(OBJLIB_DIR)/lib%.a
	$(DXE3GEN) -o $@ -I $(OBJLIB_DIR)/lib$*_i.a --whole-archive -U $< \
   -D "$* library"

$(SRC_TAB)/t%.c: $(LIB)/%.dxe
	$(DXE3RES) -o $@ $<

$(BIN_OBJ_DIR)/t%.o: $(SRC_TAB)/t%.c
	$(CC) -Wall -c $< -o $@


