#-------------
# Base Models
#-------------
DISTO = 1
ASRC  = 1
BJT   = 1
BSIM1 = 1
BSIM2 = 1
CAP   = 1
CCCS  = 1
CCVS  = 1
CSW   = 1
DIO   = 1
IND   = 1
ISRC  = 1
JFET  = 1
LTRA  = 1
MES   = 1
MOS1  = 1
MOS2  = 1
MOS3  = 1
MOS6  = 1
RES   = 1
SW    = 1
TRA   = 1
URC   = 1
VCCS  = 1
VCVS  = 1
VSRC  = 1

ifdef ASRC
DEVICES += asrc
DEFS += -DDEV_asrc
OBJDIRS += $(OBJS_DIR)/dev/asrc
LIBDEV += $(LIB)/libasrc.a
include src/lib/dev/asrc/asrc.mak
endif

ifdef BJT
DEVICES += bjt
DEFS += -DDEV_bjt
OBJDIRS += $(OBJS_DIR)/dev/bjt
LIBDEV += $(LIB)/libbjt.a
include src/lib/dev/bjt/bjt.mak
endif

ifdef BSIM1
DEVICES += bsim1
DEFS += -DDEV_bsim1
OBJDIRS += $(OBJS_DIR)/dev/bsim1
LIBDEV += $(LIB)/libbsim1.a
include src/lib/dev/bsim1/bsim1.mak
endif

ifdef BSIM2
DEVICES += bsim2
DEFS += -DDEV_bsim2
OBJDIRS += $(OBJS_DIR)/dev/bsim2
LIBDEV += $(LIB)/libbsim2.a
include src/lib/dev/bsim2/bsim2.mak
endif

ifdef CAP
DEVICES += cap
DEFS += -DDEV_cap
OBJDIRS += $(OBJS_DIR)/dev/cap
LIBDEV += $(LIB)/libcap.a
include src/lib/dev/cap/cap.mak
endif

ifdef CCCS
DEVICES += cccs
DEFS += -DDEV_cccs
OBJDIRS += $(OBJS_DIR)/dev/cccs
LIBDEV += $(LIB)/libcccs.a
include src/lib/dev/cccs/cccs.mak
endif

ifdef CCVS
DEVICES += ccvs
DEFS += -DDEV_ccvs
OBJDIRS += $(OBJS_DIR)/dev/ccvs
LIBDEV += $(LIB)/libccvs.a
include src/lib/dev/ccvs/ccvs.mak
endif

ifdef CSW
DEVICES += csw
DEFS += -DDEV_csw
OBJDIRS += $(OBJS_DIR)/dev/csw
LIBDEV += $(LIB)/libcsw.a
include src/lib/dev/csw/csw.mak
endif

ifdef DIO
DEVICES += dio
DEFS += -DDEV_dio
OBJDIRS += $(OBJS_DIR)/dev/dio
LIBDEV += $(LIB)/libdio.a
include src/lib/dev/dio/dio.mak
endif

ifdef IND
DEVICES += ind
DEFS += -DDEV_ind
OBJDIRS += $(OBJS_DIR)/dev/ind
LIBDEV += $(LIB)/libind.a
include src/lib/dev/ind/ind.mak
endif

ifdef ISRC
DEVICES += isrc
DEFS += -DDEV_isrc
OBJDIRS += $(OBJS_DIR)/dev/isrc
LIBDEV += $(LIB)/libisrc.a
include src/lib/dev/isrc/isrc.mak
endif

ifdef JFET
DEVICES += jfet
DEFS += -DDEV_jfet
OBJDIRS += $(OBJS_DIR)/dev/jfet
LIBDEV += $(LIB)/libjfet.a
include src/lib/dev/jfet/jfet.mak
endif

ifdef LTRA
DEVICES += ltra
DEFS += -DDEV_ltra
OBJDIRS += $(OBJS_DIR)/dev/ltra
LIBDEV += $(LIB)/libltra.a
include src/lib/dev/ltra/ltra.mak
endif

ifdef MES
DEVICES += mes
DEFS += -DDEV_mes
OBJDIRS += $(OBJS_DIR)/dev/mes
LIBDEV += $(LIB)/libmes.a
include src/lib/dev/mes/mes.mak
endif

ifdef MOS1
DEVICES += mos1
DEFS += -DDEV_mos1
OBJDIRS += $(OBJS_DIR)/dev/mos1
LIBDEV += $(LIB)/libmos1.a
include src/lib/dev/mos1/mos1.mak
endif

ifdef MOS2
DEVICES += mos2
DEFS += -DDEV_mos2
OBJDIRS += $(OBJS_DIR)/dev/mos2
LIBDEV += $(LIB)/libmos2.a
include src/lib/dev/mos2/mos2.mak
endif

ifdef MOS3
DEVICES += mos3
DEFS += -DDEV_mos3
OBJDIRS += $(OBJS_DIR)/dev/mos3
LIBDEV += $(LIB)/libmos3.a
include src/lib/dev/mos3/mos3.mak
endif

ifdef MOS6
DEVICES += mos6
DEFS += -DDEV_mos6
OBJDIRS += $(OBJS_DIR)/dev/mos6
LIBDEV += $(LIB)/libmos6.a
include src/lib/dev/mos6/mos6.mak
endif

ifdef RES
DEVICES += res
DEFS += -DDEV_res
OBJDIRS += $(OBJS_DIR)/dev/res
LIBDEV += $(LIB)/libres.a
include src/lib/dev/res/res.mak
endif

ifdef SW
DEVICES += sw
DEFS += -DDEV_sw
OBJDIRS += $(OBJS_DIR)/dev/sw
LIBDEV += $(LIB)/libsw.a
include src/lib/dev/sw/sw.mak
endif

ifdef TRA
DEVICES += tra
DEFS += -DDEV_tra
OBJDIRS += $(OBJS_DIR)/dev/tra
LIBDEV += $(LIB)/libtra.a
include src/lib/dev/tra/tra.mak
endif

ifdef URC
DEVICES += urc
DEFS += -DDEV_urc
OBJDIRS += $(OBJS_DIR)/dev/urc
LIBDEV += $(LIB)/liburc.a
include src/lib/dev/urc/urc.mak
endif

ifdef VCCS
DEVICES += vccs
DEFS += -DDEV_vccs
OBJDIRS += $(OBJS_DIR)/dev/vccs
LIBDEV += $(LIB)/libvccs.a
include src/lib/dev/vccs/vccs.mak
endif

ifdef VCVS
DEVICES += vcvs
DEFS += -DDEV_vcvs
OBJDIRS += $(OBJS_DIR)/dev/vcvs
LIBDEV += $(LIB)/libvcvs.a
include src/lib/dev/vcvs/vcvs.mak
endif

ifdef VSRC
DEVICES += vsrc
DEFS += -DDEV_vsrc
OBJDIRS += $(OBJS_DIR)/dev/vsrc
LIBDEV += $(LIB)/libvsrc.a
include src/lib/dev/vsrc/vsrc.mak
endif


#--------------
# Extra Models
#--------------
BSIM3     = 1
B3SOI     = 1
#B3SOIPD   = 1
#B3SOIFD   = 1
#B3SOIDD   = 1
BSIM4     = 1
#BJT2      = 1
#HISIM1    = 1
#MOS9      = 1
#HFET1     = 1
#EKV        = 1
#MODELLA    = 1
#MEXTRAM    = 1

ifdef BSIM3
DEVICES += bsim3
DEFS += -DDEV_bsim3
OBJDIRS += $(OBJS_DIR)/dev/bsim3
LIBDEV += $(LIB)/libbsim3.a
include src/lib/dev/bsim3/bsim3.mak
endif

ifdef B3SOI
DEVICES += bsim3soi
DEFS += -DDEV_b3soi
OBJDIRS += $(OBJS_DIR)/dev/bsim3soi
LIBDEV += $(LIB)/libbsim3soi.a
include src/lib/dev/bsim3soi/bsim3soi.mak
endif

ifdef B3SOIPD
DEVICES += bsim3soi_pd
DEFS += -DDEV_b3soipd
OBJDIRS += $(OBJS_DIR)/dev/bsim3soi_pd
LIBDEV += $(LIB)/libbsim3soi_pd.a
include src/lib/dev/bsim3soi_pd/bsim3soi_pd.mak
endif

ifdef B3SOIFD
DEVICES += bsim3soi_fd
DEFS += -DDEV_b3soifd
OBJDIRS += $(OBJS_DIR)/dev/bsim3soi_fd
LIBDEV += $(LIB)/libbsim3soi_fd.a
include src/lib/dev/bsim3soi_fd/bsim3soi_fd.mak
endif

ifdef B3SOIDD
DEVICES += bsim3soi_dd
DEFS += -DDEV_b3soidd
OBJDIRS += $(OBJS_DIR)/dev/bsim3soi_dd
LIBDEV += $(LIB)/libbsim3soi_dd.a
include src/lib/dev/bsim3soi_dd/bsim3soi_dd.mak
endif

ifdef BSIM4
DEVICES += bsim4
DEFS += -DDEV_bsim4
OBJDIRS += $(OBJS_DIR)/dev/bsim4
LIBDEV += $(LIB)/libbsim4.a
include src/lib/dev/bsim4/bsim4.mak
endif

ifdef BJT2
DEVICES += bjt2
DEFS += -DDEV_bjt2
OBJDIRS += $(OBJS_DIR)/dev/bjt2
LIBDEV += $(LIB)/libbjt2.a
include src/lib/dev/bjt2/bjt2.mak
endif

ifdef HISIM1
DEVICES += hisim
DEFS += -DDEV_hisim1
OBJDIRS += $(OBJS_DIR)/dev/hisim1
LIBDEV += $(LIB)/libhisim1.a
include src/lib/dev/hisim1/hisim1.mak
endif

ifdef MOS9
DEVICES += mos9
DEFS += -DDEV_mos9
OBJDIRS += $(OBJS_DIR)/dev/mos9
LIBDEV += $(LIB)/libmos9.a
include src/lib/dev/mos9/mos9.mak
endif

ifdef HFET1
DEVICES += hfet1
DEFS += -DDEV_hfet1
OBJDIRS += $(OBJS_DIR)/dev/hfet1
LIBDEV += $(LIB)/libhfet1.a
include src/lib/dev/hfet1/hfet1.mak
endif

ifdef EKV
DEVICES += ekv
DEFS += -DDEV_ekv
OBJDIRS += $(OBJS_DIR)/dev/ekv
LIBDEV += $(LIB)/libekv.a
include src/lib/dev/ekv/ekv.mak
endif

ifdef MODELLA
DEVICES += modella
DEFS += -DDEV_modella
OBJDIRS += $(OBJS_DIR)/dev/modella
LIBDEV += $(LIB)/libmodella.a
include src/lib/dev/modella/modella.mak
endif

ifdef MEXTRAM
DEVICES += mextram
DEFS += -DDEV_mextram
OBJDIRS += $(OBJS_DIR)/dev/mextram
LIBDEV += $(LIB)/libmextram.a
include src/lib/dev/mextram/mextram.mak
endif

