/*
 * Analyses
 */
#ifndef TABLES_ONLY
#include "analyses.h"
#endif

/*
 * Devices
 */
/*#define DEV_asrc
#define DEV_bjt
#define DEV_cap
#define DEV_cccs
#define DEV_ccvs
#define DEV_csw
#define DEV_dio
#define DEV_ind
#define DEV_isrc
#define DEV_mos1
#define DEV_mos2
#define DEV_res
#define DEV_vccs
#define DEV_vcvs
#define DEV_vsrc*/

// Optional devices
/*#define DEV_bsim1
#define DEV_bsim2
#define DEV_jfet
#define DEV_ltra
#define DEV_mes
#define DEV_mos3
#define DEV_mos6
#define DEV_sw
#define DEV_tra
#define DEV_urc*/

/* DO NOT MODIFY ANYTHING BELOW THIS LINE */

#include "version.h"

/**********
Copyright 1990 Regents of the University of California.  All rights reserved.
**********/

#include "spice.h"

#ifdef DEVICES_USED
static char *devs = DEVICES_USED;
#endif
#ifdef ANALYSES_USED
static char *ans = ANALYSES_USED;
#endif

#define CONFIG

#ifndef AN_dc

#ifdef AN_ac
#define AN_dc
#endif
#ifdef AN_pz
#define AN_dc
#endif
#ifdef AN_tran
#define AN_dc
#endif
#ifdef AN_noise
#define AN_dc
#endif
#ifdef AN_disto
#define AN_dc
#endif
#ifdef AN_sense
#define AN_dc
#endif
#ifdef AN_sense2
#define AN_dc
#endif

#endif

#include <stdio.h>
#include "noisedef.h"
#include "devdefs.h"
#include "suffix.h"

#ifdef HAS_FLAT_INCLUDES

#include "asrcitf.h"
#include "bjtitf.h"
#include "capitf.h"
#include "cccsitf.h"
#include "ccvsitf.h"
#include "cswitf.h"
#include "dioitf.h"
#include "inditf.h"
#include "isrcitf.h"
#include "mos1itf.h"
#include "mos6itf.h"
#include "resitf.h"
#include "switf.h"
#include "vccsitf.h"
#include "vcvsitf.h"
#include "vsrcitf.h"

#include "bsim1itf.h"
#include "bsim2itf.h"
#include "mos2itf.h"
#include "mos3itf.h"
#include "jfetitf.h"
#include "mesitf.h"
#include "ltraitf.h"
#include "traitf.h"
#include "urcitf.h"

#ifdef DEV_mos9
#include "mos9itf.h"
#endif
#ifdef DEV_bsim3
#include "bsim3itf.h"
#endif
#ifdef DEV_b3soi
#include "b3soiitf.h"
#endif
#ifdef DEV_b3soipd
#include "b3soipditf.h"
#endif
#ifdef DEV_b3soifd
#include "b3soifditf.h"
#endif
#ifdef DEV_b3soidd
#include "b3soidditf.h"
#endif
#ifdef DEV_bsim4
#include "bsim4itf.h"
#endif
#ifdef DEV_bjt2
#include "bjt2itf.h"
#endif
#ifdef DEV_hfet1      
#include "hfetitf.h"   
#endif                 
#ifdef DEV_ekv      
#include "ekvitf.h"
#endif   
#ifdef DEV_modella      
#include "modellaitf.h"
#endif   
#ifdef DEV_hisim1      
#include "hsm1itf.h"   
#endif                 

#else

#if !defined(DYNAMIC) && !defined(DXE)
#include "asrc/asrcitf.h"
#include "bjt/bjtitf.h"
#include "cap/capitf.h"
#include "cccs/cccsitf.h"
#include "ccvs/ccvsitf.h"
#include "csw/cswitf.h"
#include "dio/dioitf.h"
#include "ind/inditf.h"
#include "isrc/isrcitf.h"
#include "mos1/mos1itf.h"
#include "mos6/mos6itf.h"
#include "res/resitf.h"
#include "sw/switf.h"
#include "vccs/vccsitf.h"
#include "vcvs/vcvsitf.h"
#include "vsrc/vsrcitf.h"

#include "bsim1/bsim1itf.h"
#include "bsim2/bsim2itf.h"
#include "mos2/mos2itf.h"
#include "mos3/mos3itf.h"
#include "jfet/jfetitf.h"
#include "mes/mesitf.h"
#include "ltra/ltraitf.h"
#include "tra/traitf.h"
#include "urc/urcitf.h"

#ifdef DEV_mos9
#include "mos9/mos9itf.h"
#endif
#ifdef DEV_bsim3
#include "bsim3/bsim3itf.h"
#endif
#ifdef DEV_b3soi
#include "bsim3soi/b3soiitf.h"
#endif                 
#ifdef DEV_b3soipd
#include "bsim3soi_pd/b3soipditf.h"
#endif                 
#ifdef DEV_b3soifd
#include "bsim3soi_fd/b3soifditf.h"
#endif                 
#ifdef DEV_b3soidd
#include "bsim3soi_dd/b3soidditf.h"
#endif                 
#ifdef DEV_bsim4
#include "bsim4/bsim4itf.h"
#endif
#ifdef DEV_bjt2
#include "bjt2/bjt2itf.h"
#endif
#ifdef DEV_hfet1             
#include "hfet1/hfetitf.h"  
#endif                        
#ifdef DEV_ekv             
#include "ekv/ekvitf.h"  
#endif                        
#ifdef DEV_modella             
#include "modella/modellaitf.h"  
#endif                        
#ifdef DEV_hisim1             
#include "hisim1/hsm1itf.h"  
#endif                        

#endif
#endif

#ifndef TABLES_ONLY
extern IMPORT SPICEanalysis OPTinfo;
extern IMPORT SPICEanalysis ACinfo;
extern IMPORT SPICEanalysis DCTinfo;
extern IMPORT SPICEanalysis DCOinfo;
extern IMPORT SPICEanalysis TRANinfo;
extern IMPORT SPICEanalysis PZinfo;
extern IMPORT SPICEanalysis SEN2info;
extern IMPORT SPICEanalysis TFinfo;
extern IMPORT SPICEanalysis DISTOinfo;
extern IMPORT SPICEanalysis NOISEinfo;
extern IMPORT SPICEanalysis SENSinfo;
#endif

#ifndef DYNAMIC
SPICEanalysis *MyanalInfo[] = {
#ifndef TABLES_ONLY
    &OPTinfo,
#ifdef AN_ac
    &ACinfo,
#endif
#ifdef AN_dc
    &DCTinfo,
#endif
#ifdef AN_op
    &DCOinfo,
#endif
#ifdef AN_tran
    &TRANinfo,
#endif
#ifdef AN_pz
    &PZinfo,
#endif
#ifdef AN_sense2
    &SEN2info,
#endif
#ifdef AN_tf
    &TFinfo,
#endif
#ifdef AN_disto
    &DISTOinfo,
#endif
#ifdef AN_noise
    &NOISEinfo,
#endif
#ifdef AN_sense
    &SENSinfo,
#endif
#else
    NULL
#endif
};
#else
SPICEanalysis *MyanalInfo[] = {
#ifndef TABLES_ONLY
    0,  // &OPTinfo
#ifdef AN_ac
    0,  // &ACinfo
#endif
#ifdef AN_dc
    0,  // &DCTinfo
#endif
#ifdef AN_op
    0,  // &DCOinfo
#endif
#ifdef AN_tran
    0,  // &TRANinfo
#endif
#ifdef AN_pz
    0,  // &PZinfo
#endif
#ifdef AN_sense2
    0,  // &SEN2info
#endif
#ifdef AN_tf
    0,  // &TFinfo
#endif
#ifdef AN_disto
    0,  // &DISTOinfo
#endif
#ifdef AN_noise
    0,  // &NOISEinfo
#endif
#ifdef AN_sense
    0,  // &SENSinfo
#endif
#else
    NULL
#endif
};
#endif  // DYNAMIC

int MyANALmaxnum = sizeof(MyanalInfo)/sizeof(SPICEanalysis*);

#if !defined(DYNAMIC) && !defined(DXE)
SPICEdev *MyDEVices[] = {

#ifdef DEV_urc
	// URC must appear before the resistor, capacitor, and diode
        &URCinfo,
#endif
#ifdef DEV_asrc
        &ASRCinfo,
#endif
#ifdef DEV_bjt
        &BJTinfo,
#endif
#ifdef DEV_bsim1
        &B1info,
#endif
#ifdef DEV_bsim2
        &B2info,
#endif
#ifdef DEV_cap
        &CAPinfo,
#endif
#ifdef DEV_cccs
        &CCCSinfo,
#endif
#ifdef DEV_ccvs
        &CCVSinfo,
#endif
#ifdef DEV_csw
        &CSWinfo,
#endif
#ifdef DEV_dio
        &DIOinfo,
#endif
#ifdef DEV_ind
        &INDinfo,
        &MUTinfo,
#endif
#ifdef DEV_isrc
        &ISRCinfo,
#endif
#ifdef DEV_jfet
        &JFETinfo,
#endif
#ifdef DEV_ltra
        &LTRAinfo,
#endif
#ifdef DEV_mes
        &MESinfo,
#endif
#ifdef DEV_mos1
        &MOS1info,
#endif
#ifdef DEV_mos2
        &MOS2info,
#endif
#ifdef DEV_mos3
        &MOS3info,
#endif
#ifdef DEV_mos6
        &MOS6info,
#endif
#ifdef DEV_res
        &RESinfo,
#endif
#ifdef DEV_sw
        &SWinfo,
#endif
#ifdef DEV_tra
        &TRAinfo,
#endif
#ifdef DEV_vccs
        &VCCSinfo,
#endif
#ifdef DEV_vcvs
        &VCVSinfo,
#endif
#ifdef DEV_vsrc
        &VSRCinfo,
#endif
#ifdef DEV_mos9
        &MOS9info,
#endif
#ifdef DEV_bsim3
        &BSIM3info,
#endif
#ifdef DEV_b3soi
        &B3SOIinfo,
#endif
#ifdef DEV_b3soipd
        &B3SOIPDinfo,
#endif
#ifdef DEV_b3soifd
        &B3SOIFDinfo,
#endif
#ifdef DEV_b3soidd
        &B3SOIDDinfo,
#endif
#ifdef DEV_bsim4
        &BSIM4info,
#endif
#ifdef DEV_bjt2
        &BJT2info,
#endif
#ifdef DEV_ekv   
       &EKVinfo,   
#endif              
#ifdef DEV_modella   
       &MODELLAinfo,   
#endif              
#ifdef DEV_hfet1   
       &HFETAinfo,   
#endif              
#ifdef DEV_hisim1   
       &HSM1info,   
#endif              
};
#else
SPICEdev *MyDEVices[] = {

0,  //  0 &URCinfo
0,  //  1 &ASRCinfo
0,  //  2 &BJTinfo
0,  //  3 &B1info
0,  //  4 &B2info
0,  //  5 &CAPinfo
0,  //  6 &CCCSinfo
0,  //  7 &CCVSinfo
0,  //  8 &CSWinfo
0,  //  9 &DIOinfo
0,  // 10 &INDinfo
0,  // 11 &MUTinfo
0,  // 12 &ISRCinfo
0,  // 13 &JFETinfo
0,  // 14 &LTRAinfo
0,  // 15 &MESinfo
0,  // 16 &MOS1info
0,  // 17 &MOS2info
0,  // 18 &MOS3info
0,  // 19 &MOS6info
0,  // 20 &RESinfo
0,  // 21 &SWinfo
0,  // 22 &TRAinfo
0,  // 23 &VCCSinfo
0,  // 24 &VCVSinfo
0,  // 25 &VSRCinfo
       
#ifdef DEV_mos9
0,  // 26 &MOS9info
#endif
#ifdef DEV_bsim3
0,  // 27 &BSIM3info
#endif
#ifdef DEV_b3soi
0,  // 28 &B3SOIinfo
#endif
#ifdef DEV_b3soipd
0,  // 29 &B3SOIPDinfo
#endif
#ifdef DEV_b3soifd
0,  // 30 &B3SOIFDinfo
#endif
#ifdef DEV_b3soidd
0,  // 31 &B3SOIDDinfo
#endif
#ifdef DEV_bsim4
0,  // 32 &BSIM4info
#endif
#ifdef DEV_bjt2
0,  // 33 &BJT2info
#endif
#ifdef DEV_ekv
0,  // 34 &EKVinfo
#endif
#ifdef DEV_modella
0,  // 34 &MODELLAinfo
#endif
#ifdef DEV_hfet1
0,  // 35 &HFETAinfo
#endif

/*#ifdef DEV_hisim1   
       &HSM1info,   
#endif*/              
};
#endif  // DYNAMIC

// my internal global constant for number of device types
/*#ifndef DYNAMIC
int DEVmaxnum = sizeof(DEVices)/sizeof(SPICEdev *);
#else*/
int MyDEVmaxnum = sizeof(MyDEVices)/sizeof(SPICEdev *);
//#endif  // DYNAMIC

/* XXX Should be -1 ? There is always an extra null element at the end ? */
static char * specSigList[] = {
    "time"
};

static IFparm nodeParms[] = {
    IP( "nodeset",PARM_NS ,IF_REAL,"suggested initial voltage"),
    IP( "ic",PARM_IC ,IF_REAL,"initial voltage"),
    IP( "type",PARM_NODETYPE ,IF_INTEGER,"output type of equation")
};

IFsimulator SIMinfo = {
    "Spice+",       /* name */
    "Spice+ circuit level simulation program",  /* more about me */
#ifndef TABLES_ONLY
    //Spice_Version,          /* version */
    SPICE_VERSION,          /* version */

    CKTinit,        /* newCircuit function */
    CKTdestroy,     /* deleteCircuit function */

    CKTnewNode,     /* newNode function */
    CKTground,      /* groundNode function */
    CKTbindNode,    /* bindNode function */
    CKTfndNode,     /* findNode function */
    CKTinst2Node,   /* instToNode function */
    CKTsetNodPm,    /* setNodeParm function */
    CKTaskNodQst,   /* askNodeQuest function */
    CKTdltNod,      /* deleteNode function */

    CKTcrtElt,      /* newInstance function */
    CKTparam,       /* setInstanceParm function */
    CKTask,         /* askInstanceQuest function */
    CKTfndDev,      /* findInstance funciton */
    CKTdltInst,     /* deleteInstance function */

    CKTmodCrt,      /* newModel function */
    CKTmodParam,    /* setModelParm function */
    CKTmodAsk,      /* askModelQuest function */
    CKTfndMod,      /* findModel function */
    CKTdltMod,      /* deleteModel function */

    CKTnewTask,     /* newTask function */
    CKTnewAnal,     /* newAnalysis function */
    CKTsetAnalPm,   /* setAnalysisParm function */
    CKTaskAnalQ,    /* askAnalysisQuest function */
    CKTfndAnal,     /* findAnalysis function */
    CKTfndTask,     /* findTask function */
    CKTdelTask,     /* deleteTask function */

    CKTdoJob,       /* doAnalyses function */
    CKTtrouble,	    /* non-convergence message function */

    /*#ifndef DYNAMIC
    sizeof(DEVices)/sizeof(SPICEdev *),
    (IFdevice**)DEVices,
    #else*/
    sizeof(MyDEVices)/sizeof(SPICEdev *),
    (IFdevice**)MyDEVices,
    //#endif  // DYNAMIC

    sizeof(MyanalInfo)/sizeof(SPICEanalysis *),
    (IFanalysis **)MyanalInfo,

    sizeof(nodeParms)/sizeof(IFparm),
    nodeParms,

    sizeof(specSigList)/sizeof(char *),
    specSigList,
#endif
};
