
#define MAXNUMPLOT 4
#define DIMSTRING 512

typedef struct
{
int x;
int y;
int w;
int h;
} SPICE_RECT;

struct videoconfig {
        int numxpixels;
        int numypixels;
        int numcolors;
        };

typedef struct PLOT
{
GRAPH *graphic;
wordlist *tracelist;
int ntrace;
SPICE_RECT rgraph;
} PLOT;

struct plotparam
{
double ylo;
double yhi;
double xlo;
double xhi;
GRIDTYPE gtype;
char *xaxis;
} plotparam;

// Video Configuration
extern struct videoconfig config;
extern int screen_type;
extern int mfbpc_width;
extern int mfbpc_height;
extern int menu_width;
extern int graph_mode_on;

// Mouse coordinates
extern volatile int mouse_x;
extern volatile int mouse_y;

// Colors and Styles
extern int currcolor;
extern unsigned short sel_style;

// Plots
extern PLOT dataplot[MAXNUMPLOT];
extern PLOT *curr_dataplot;
extern int curr_plot;
extern int num_plot;
extern int set_x_limits;
extern int set_y_limits;
extern int set_xaxis;

#ifdef ALLEGRO
#include "mfballeg.h"
#endif

#ifdef GTK
#include "mfbgtk.h"
#endif

#ifdef GDI
#include "mfbgdi.h"
#endif

#include "cursaux.h"

extern void Replot(int plot);
extern void set_plot_param();
extern void check_param();

