
typedef struct sModLib {
    char *name;                 // name of this type of device
    char *library;              // name of the dll
    char *infoname;             // name of the info structure
} ModLib;

#ifdef __MINGW32__
#define LIBPREF "lib"
#define LIBSUFF ".dll"
#define INFOPREF ""
#endif
#ifdef DXE
#define LIBPREF ""
#define LIBSUFF ".dxe"
#define INFOPREF "_"
#endif
#if (defined DYNAMIC) && (defined linux)
#define LIBPREF "lib"
#define LIBSUFF ".so"
#define INFOPREF ""
#endif

static ModLib MyModLib[] = {
    { "URC"      , LIBPREF"urc"LIBSUFF       , INFOPREF"URCinfo"     }, // 0
    { "ASRC"     , LIBPREF"asrc"LIBSUFF      , INFOPREF"ASRCinfo"    }, // 1
    { "BJT"      , LIBPREF"bjt"LIBSUFF       , INFOPREF"BJTinfo"     }, // 2
    { "BSIM1"    , LIBPREF"bsim1"LIBSUFF     , INFOPREF"B1info"      }, // 3
    { "BSIM2"    , LIBPREF"bsim2"LIBSUFF     , INFOPREF"B2info"      }, // 4
    { "Capacitor", LIBPREF"cap"LIBSUFF       , INFOPREF"CAPinfo"     }, // 5
    { "CCCS"     , LIBPREF"cccs"LIBSUFF      , INFOPREF"CCCSinfo"    }, // 6
    { "CCVS"     , LIBPREF"ccvs"LIBSUFF      , INFOPREF"CCVSinfo"    }, // 7
    { "CSwitch"  , LIBPREF"csw"LIBSUFF       , INFOPREF"CSWinfo"     }, // 8
    { "Diode"    , LIBPREF"dio"LIBSUFF       , INFOPREF"DIOinfo"     }, // 9
    { "Inductor" , LIBPREF"ind"LIBSUFF       , INFOPREF"INDinfo"     }, // 10
    { "mutual"   , LIBPREF"ind"LIBSUFF       , INFOPREF"MUTinfo"     }, // 11
    { "Isource"  , LIBPREF"isrc"LIBSUFF      , INFOPREF"ISRCinfo"    }, // 12
    { "JFET"     , LIBPREF"jfet"LIBSUFF      , INFOPREF"JFETinfo"    }, // 13
    { "LTRA"     , LIBPREF"ltra"LIBSUFF      , INFOPREF"LTRAinfo"    }, // 14
    { "MES"      , LIBPREF"mes"LIBSUFF       , INFOPREF"MESinfo"     }, // 15
    { "Mos1"     , LIBPREF"mos1"LIBSUFF      , INFOPREF"MOS1info"    }, // 16
    { "Mos2"     , LIBPREF"mos2"LIBSUFF      , INFOPREF"MOS2info"    }, // 17
    { "Mos3"     , LIBPREF"mos3"LIBSUFF      , INFOPREF"MOS3info"    }, // 18
    { "Mos6"     , LIBPREF"mos6"LIBSUFF      , INFOPREF"MOS6info"    }, // 19
    { "Resistor" , LIBPREF"res"LIBSUFF       , INFOPREF"RESinfo"     }, // 20
    { "Switch"   , LIBPREF"sw"LIBSUFF        , INFOPREF"SWinfo"      }, // 21
    { "Tranline" , LIBPREF"tra"LIBSUFF       , INFOPREF"TRAinfo"     }, // 22
    { "VCCS"     , LIBPREF"vccs"LIBSUFF      , INFOPREF"VCCSinfo"    }, // 23
    { "VCVS"     , LIBPREF"vcvs"LIBSUFF      , INFOPREF"VCVSinfo"    }, // 24
    { "Vsource"  , LIBPREF"vsrc"LIBSUFF      , INFOPREF"VSRCinfo"    }, // 25

//    { "MOS9"     , LIBPREF"mos9"LIBSUFF      , INFOPREF"MOS9info"    }, // 26
    { "BSIM3"    , LIBPREF"bsim3"LIBSUFF     , INFOPREF"BSIM3info"   }, // 27
//    { "B3SOI"    , LIBPREF"bsim3soi"LIBSUFF  , INFOPREF"B3SOIinfo"   }, // 28
//    { "B3SOIPD"  , LIBPREF"bsim3soipd"LIBSUFF, INFOPREF"B3SOIPDinfo" }, // 29
//    { "B3SOIFD"  , LIBPREF"bsim3soifd"LIBSUFF, INFOPREF"B3SOIFDinfo" }, // 30
//    { "B3SOIDD"  , LIBPREF"bsim3soidd"LIBSUFF, INFOPREF"B3SOIDDinfo" }, // 31
    { "BSIM4"    , LIBPREF"bsim4"LIBSUFF     , INFOPREF"BSIM4info"   }, // 32
//    { "BJT2"     , LIBPREF"bjt2"LIBSUFF      , INFOPREF"BJT2info"    }, // 33
//    { "HFET1"    , LIBPREF"hfet1"LIBSUFF     , INFOPREF"HFETAinfo"   }, // 34
    { "EKV"      , LIBPREF"ekv"LIBSUFF       , INFOPREF"EKVinfo"     }, // 35
    { "MODELLA"  , LIBPREF"modella"LIBSUFF   , INFOPREF"MODELLAinfo" }, // 36
};

int MyModmaxnum = sizeof(MyModLib)/sizeof(ModLib);

