
CKT_COBJS = acan.o acaskq.o acsetp.o cktaccpt.o cktacct.o cktacdum.o \
            cktacl.o cktask.o cktaskaq.o cktasknq.o cktbindn.o \
            cktbkdum.o cktclrbk.o cktcrte.o cktdelt.o \
            cktdest.o cktdisto.o cktdlti.o cktdltm.o cktdltn.o \
            cktdojob.o cktdump.o cktfbran.o cktfdev.o cktfnda.o \
            cktfndm.o cktfnode.o cktftask.o cktgrnd.o ckti2nod.o \
            cktic.o cktinit.o cktlnkeq.o cktload.o cktmapn.o cktmask.o \
            cktmcrt.o cktmkcur.o cktmknod.o cktmkvol.o cktmpar.o \
            cktnames.o cktnewan.o cktneweq.o cktnewn.o cktnodn.o \
            cktnoise.o cktntask.o cktnum2n.o cktop.o cktparam.o \
            cktpmnam.o cktpname.o cktpzld.o cktpzset.o cktpzstr.o \
            cktsens.o cktsetap.o cktsetbk.o cktsetnp.o cktsetup.o \
            cktsgen.o cktsopt.o ckttemp.o cktterr.o ckttroub.o \
            ckttrunc.o ckttyplk.o daskq.o dcoaskq.o dcop.o dcosetp.o \
            dctaskq.o dctran.o dctrcurv.o dctsetp.o distoan.o dkerproc.o \
            dloadfns.o dsetparm.o naskq.o nevalsrc.o ninteg.o noisean.o \
            nsetparm.o pzan.o pzaskq.o pzsetp.o sensaskq.o senssetp.o \
            tfanal.o tfaskq.o tfsetp.o tranaskq.o traninit.o transetp.o \
            zaddeq.o

CKT_SRC_DIR     = src/lib/ckt
CKT_OBJ_DIR     = $(OBJS_DIR)/ckt

CKT_OBJ         = $(addprefix $(CKT_OBJ_DIR)/,$(CKT_COBJS))
CKT_LIBRARY     = ckt
CKT_LIB         = $(OBJLIB_DIR)/lib$(CKT_LIBRARY).a

ckt: $(CKT_LIB)

$(CKT_LIB): $(CKT_OBJ)
	@echo Archiving $@...
	$(AR) rcs $@ $^

$(CKT_OBJ_DIR)/%.o: $(CKT_SRC_DIR)/%.c
	@echo Compiling $<...
	$(CC) $(FLAGS) $(INCLUDE) -c $< -o $@

ckt_clean:
	@echo Deleting ckt library...
	$(RM) $(CKT_LIB)
	$(RM) -r $(CKT_OBJ)


CIRCUIT_LIBRARY     = circuit
CIRCUIT_LIB         = $(OBJLIB_DIR)/lib$(CIRCUIT_LIBRARY).a

ifdef DLL
$(CIRCUIT_LIB): lib$(CIRCUIT_LIBRARY).dll

lib$(CIRCUIT_LIBRARY).dll: $(CKT_OBJ) $(NI_OBJ)
	@echo Creating DLL $@...
	$(CC) -shared -o $@ -Wl,--out-implib=$(OBJLIB_DIR)/libcircuit.a $^ \
   -L$(OBJLIB_DIR) -lsparse -lmisc -lglobal

else
ifdef SO
$(CIRCUIT_LIB): lib$(CIRCUIT_LIBRARY).so

lib$(CIRCUIT_LIBRARY).so: $(CKT_OBJ) $(NI_OBJ)
	@echo Creating Shared Library $@...
	$(CC) -shared -o $@ $^ -L. -lsparse -lmisc -lglobal

endif
endif

