
OPT_COBJS = cktacct.o cktsopt.o

OPT_SRC_DIR     = src/lib/ckt
OPT_OBJ_DIR     = $(OBJS_DIR)/ckt

OPT_OBJ         = $(addprefix $(OPT_OBJ_DIR)/,$(OPT_COBJS))
OPT_LIBRARY     = opt
OPT_LIB         = $(OBJLIB_DIR)/lib$(OPT_LIBRARY).a

opt: $(OPT_LIB)

ifdef DLL
$(OPT_LIB): lib$(OPT_LIBRARY).dll

lib$(OPT_LIBRARY).dll: $(OPT_OBJ)
	@echo Creating DLL $@...
	$(CC) -shared -o $@ -Wl,--out-implib=$(OBJLIB_DIR)/lib$(OPT_LIBRARY).a $^ \
   -L$(OBJLIB_DIR) -lsparse -lmisc -lglobal

else
ifdef SO
$(OPT_LIB): lib$(OPT_LIBRARY).so

lib$(OPT_LIBRARY).so: $(OPT_OBJ)
	@echo Creating Shared Library $@...
	$(CC) -shared -o $@ $^ -L$(OBJLIB_DIR) -lsparse -lmisc -lglobal
	@echo Archiving $(OPT_LIB)...
	$(AR) rcs $(OPT_LIB) $^

endif
endif

