/**********
Copyright 1990 Regents of the University of California.  All rights reserved.
**********/

#include "spice.h"
#include "util.h"

EXPORT int	CKTpzTrapped;

EXPORT void zaddeq(double *a, int *amag, double x, int xmag, double y, int ymag)
{
    /* Balance magnitudes . . . */
    if (xmag > ymag) {
	*amag = xmag;
	if (xmag > 50 + ymag)
	    y = 0.0;
	else
	    for (xmag -= ymag; xmag > 0; xmag--)
		y /= 2.0;
    } else {
	*amag = ymag;
	if (ymag > 50 + xmag)
	    x = 0.0;
	else
	    for (ymag -= xmag; ymag > 0; ymag--)
		x /= 2.0;
    }

    *a = x + y;
    if (*a == 0.0)
	*amag = 0;
    else {
	while (FABS(*a) > 1.0) {
	    *a /= 2.0;
	    *amag += 1;
	}
	while (FABS(*a) < 0.5) {
	    *a *= 2.0;
	    *amag -= 1;
	}
    }
}

