
DERIV_COBJS = atander.o cosderiv.o cubeder.o divderiv.o equalder.o \
              expderiv.o invderiv.o multder.o plusder.o powderiv.o \
              sqrtder.o tanderiv.o timesder.o

DERIV_SRC_DIR      = src/lib/deriv
DERIV_OBJ_DIR      = $(OBJS_DIR)/deriv

DERIV_OBJ          = $(addprefix $(DERIV_OBJ_DIR)/,$(DERIV_COBJS))
DERIV_LIBRARY      = deriv
DERIV_LIB          = $(OBJLIB_DIR)/lib$(DERIV_LIBRARY).a

deriv: $(DERIV_LIB)

ifdef DLL
$(DERIV_LIB): lib$(DERIV_LIBRARY).dll

lib$(DERIV_LIBRARY).dll: $(DERIV_OBJ)
	@echo Creating DLL $@...
	$(CC) -shared -o $@ -Wl,--out-implib=$(DERIV_LIB) $^

else
ifdef SO
$(DERIV_LIB): lib$(DERIV_LIBRARY).so

lib$(DERIV_LIBRARY).so: $(DERIV_OBJ)
	@echo Creating Shared Library $@...
	$(CC) $(FLAGS) -shared -o $@ $^
	@echo Archiving $(DERIV_LIB)...
	$(AR) rcs $(DERIV_LIB) $^

else
$(DERIV_LIB): $(DERIV_OBJ)
	@echo Archiving $@...
	$(AR) rcs $@ $^
endif
endif
   
$(DERIV_OBJ_DIR)/%.o: $(DERIV_SRC_DIR)/%.c
	@echo Compiling $<...
	$(CC) $(FLAGS) $(INCLUDE) -c $< -o $@

deriv_clean:
	@echo Deleting deriv library...
	$(RM) $(DERIV_LIB)
	$(RM) -r $(DERIV_OBJ)
