/**********
Copyright 1990 Regents of the University of California.  All rights reserved.
**********/

#include "spice.h"
#include "ftegraph.h"
#include "ftedev.h"
#include "fteinput.h"
#include "cpdefs.h"     /* for VT_STRING */
#include "ftedefs.h"        /* for mylog() */

/* forward declarations */
static int nodev(), nop(), gen_DatatoScreen(), gen_ScreentoData(), gen_Input();

#ifdef HAS_X10
extern int  X_Init(), X_NewViewport(), X_Close(), X_Clear(),
        X_DrawLine(), X_Arc(), X_Text(), X_DefineColor(),
        X_DefineLinestyle(), X_SetLinestyle(), X_SetColor(),
        X_Update(),
        X_Track(), X_MakeMenu(), X_MakeDialog(), X_Input();
#endif

#ifdef HAS_X11
extern int  X11_Init(), X11_NewViewport(), X11_Close(), X11_Clear(),
        X11_DrawLine(), X11_Arc(), X11_Text(), X11_DefineColor(),
        X11_DefineLinestyle(), X11_SetLinestyle(), X11_SetColor(),
        X11_Update(),
        X11_Input();
#endif

#ifdef HAS_WIN
extern int  WIN_Init(), WIN_NewViewport(), WIN_Close(), WIN_Clear(),
        WIN_DrawLine(), WIN_Arc(), WIN_Text(), WIN_DefineColor(),
        WIN_DefineLinestyle(), WIN_SetLinestyle(), WIN_SetColor(),
        WIN_Update(),
        WIN_Input();
#endif

#ifdef HAS_MFB
extern int  Mfb_Init(), Mfb_NewViewport(), Mfb_Close(), Mfb_Clear(),
        Mfb_DrawLine(), Mfb_DrawHLine(), Mfb_DrawVLine(), Mfb_DrawRect(),
        Mfb_Arc(), Mfb_Text(), Mfb_DefineColor(),
        Mfb_DefineLinestyle(), Mfb_SetLinestyle(), Mfb_SetColor(),
        Mfb_Update(),
        Mfb_MakeMenu(), Mfb_MakeDialog();
#endif

#ifdef HAS_QUICKDRAW
extern int  QDraw_Init(), QDraw_NewViewport(), QDraw_Clear(),
        QDraw_DrawLine(), QDraw_Arc(), QDraw_Text(),
        QDraw_SetLinestyle(), QDraw_SetColor(),
        QDraw_Input(), QDraw_DatatoScreen();

extern int apple_Init(), apple_NewViewport(), apple_Close(),
        apple_Text(), apple_SetLinestyle();

#endif

extern int  Plt5_Init(), Plt5_NewViewport(), Plt5_Close(), Plt5_Clear(),
        Plt5_DrawLine(), Plt5_Arc(), Plt5_Text(),
        Plt5_DefineLinestyle(), Plt5_SetLinestyle(), Plt5_SetColor(),
        Plt5_Update();

extern int  PS_Init(), PS_NewViewport(), PS_Close(), PS_Clear(),
        PS_DrawLine(), PS_Arc(), PS_Text(),
        PS_DefineLinestyle(), PS_SetLinestyle(), PS_SetColor(),
        PS_Update();

DISPDEVICE device[] = {

    {"error", 0, 0, 0, 0, 0, 0, nop, nop,
    nop, nop,
    nop, nop, nop, nop, nop,
    nop, nop, nop,
    nop, nop, nop, gen_Input,
    nop,},

#ifdef HAS_X11
    {"X11", 0, 0, 1024, 864, 0, 0, X11_Init, X11_NewViewport,
    X11_Close, X11_Clear,
    X11_DrawLine, X11_Arc, X11_Text, X11_DefineColor, X11_DefineLinestyle,
    X11_SetLinestyle, X11_SetColor, X11_Update,
    nodev, nodev, nodev, X11_Input,
    gen_DatatoScreen,},
#endif

#ifdef HAS_X10
    {"X", 0, 0, 1024, 864, 0, 0, X_Init, X_NewViewport,
    X_Close, X_Clear,
    X_DrawLine, X_Arc, X_Text, X_DefineColor, X_DefineLinestyle,
    X_SetLinestyle, X_SetColor, X_Update,
    X_Track, X_MakeMenu, X_MakeDialog, X_Input,
    gen_DatatoScreen,},
#endif

#ifdef HAS_MFB
    {"MFB", 0, 0, 1000, 1000, 0, 0, Mfb_Init, Mfb_NewViewport,
    Mfb_Close, Mfb_Clear,
    Mfb_DrawLine, Mfb_DrawHLine, Mfb_DrawVLine, Mfb_DrawRect, Mfb_Arc,
    Mfb_Text, Mfb_DefineColor, Mfb_DefineLinestyle,
    Mfb_SetLinestyle, Mfb_SetColor, Mfb_Update,
    nodev, Mfb_MakeMenu, Mfb_MakeDialog, gen_Input,
    gen_DatatoScreen, gen_ScreentoData,},
#endif

#ifdef HAS_QUICKDRAW
    {"QuickDraw", 0, 0, 1000, 1000, 0, 0, QDraw_Init, QDraw_NewViewport,
    nodev, QDraw_Clear,
    QDraw_DrawLine, QDraw_Arc, QDraw_Text, nodev, nodev,
    QDraw_SetLinestyle, nop, nop,
    nodev, nodev, nodev, QDraw_Input,
    QDraw_DatatoScreen,},
    
    {"appleprinter", 0, 0, 1000, 1000, 0, 0, apple_Init, apple_NewViewport,
    apple_Close, nop,
    QDraw_DrawLine, QDraw_Arc, QDraw_Text, nodev, nodev,
    apple_SetLinestyle, nop, nop,
    nodev, nodev, nodev, nodev,
    gen_DatatoScreen,},

#endif

    {"plot5", 0, 0, 1000, 1000, 0, 0, Plt5_Init, Plt5_NewViewport,
    Plt5_Close, Plt5_Clear,
    Plt5_DrawLine, Plt5_Arc, Plt5_Text, nodev, nodev,
    Plt5_SetLinestyle, Plt5_SetColor, Plt5_Update,
    nodev, nodev, nodev, nodev,
    gen_DatatoScreen,},

    {"postscript", 0, 0, 1000, 1000, 0, 0, PS_Init, PS_NewViewport,
    PS_Close, PS_Clear,
    PS_DrawLine, PS_Arc, PS_Text, nodev, nodev,
    PS_SetLinestyle, PS_SetColor, PS_Update,
    nodev, nodev, nodev, nodev,
    gen_DatatoScreen,},

    {"printf", 0, 0, 24, 80, 0, 0, nodev, nodev,
    nodev, nodev,
    nodev, nodev, nodev, nodev, nodev,
    nodev, nodev, nodev,
    nodev, nodev, nodev, gen_Input,
    nodev,},

};

DISPDEVICE *dispdev = device + NUMELEMS(device) - 1;

#define XtNumber(arr)       (sizeof(arr) / sizeof(arr[0]))

EXPORT DISPDEVICE *FindDev(char *name)
{
    int i;

    for (i=0; i < XtNumber(device); i++) {
      if (!strcmp(name, device[i].name)) {
        return(&device[i]);
      }
    }
    sprintf(ErrorMessage, "Can't find device %s.", name);
    internalerror(ErrorMessage);
    return(&device[0]);

}

EXPORT void
DevInit()
{
#ifdef HAS_X_
    char buf[128];
#endif

/* note: do better determination */

/*
    dumb tradition that got passed on from gi_interface
    to do compile time determination
*/

    dispdev = NULL;
#ifdef HAS_X_
    /* determine display type */
    if (getenv("DISPLAY") || cp_getvar("display", VT_STRING, buf)) {
#ifdef HAS_X10
      dispdev = FindDev("X");
#endif
#ifdef HAS_X11
      dispdev = FindDev("X11");
#endif
    }
#endif

#ifdef HAS_MFB
    if (!dispdev) {
      dispdev = FindDev("MFB");
    }
#endif

#ifdef HAS_QUICKDRAW
    if (!dispdev) {
      dispdev = FindDev("QuickDraw");
    }
#endif

    if (!dispdev) {
	externalerror(
	 "no graphics interface; please check compiling instructions");
	dispdev = FindDev("error");
    } else if ((*(dispdev->Init))()) {
      fprintf(cp_err,
        "Warning: can't initialize display device for graphics.\n");
      dispdev = FindDev("error");
    }

}

/* NewViewport is responsible for filling in graph->viewport */
EXPORT int
NewViewport(GRAPH *pgraph)
{

    return (*(dispdev->NewViewport))(pgraph);

}

EXPORT void
DevClose()
{

    (*(dispdev->Close))();

}

EXPORT void
DevClear()
{

    (*(dispdev->Clear))();

}

EXPORT void
DrawLine(int x1, int y1, int x2, int y2)
{
    (*(dispdev->DrawLine))(x1, y1, x2, y2);
}

EXPORT void
DrawHLine(int x1, int y1, int x2)
{
    (*(dispdev->DrawHLine))(x1, y1, x2);
}

EXPORT void
DrawVLine(int x1, int y1, int y2)
{
    (*(dispdev->DrawVLine))(x1, y1, y2);
}

EXPORT void
DrawRect(int x1, int y1, int x2, int y2)
{
    (*(dispdev->DrawRect))(x1, y1, x2, y2);
}

EXPORT void
DrawArc(int x0, int y0, int radius, double theta1, double theta2)
{

    (*(dispdev->Arc))(x0, y0, radius, theta1, theta2);

}

EXPORT void
Text(char *text, int x, int y)
{

    (*(dispdev->Text))(text, x, y);

}

EXPORT void
DefineColor(int colorid, double red, double green, double blue)
{

    (*(dispdev->DefineColor))(colorid, red, green, blue);

}

EXPORT void
DefineLinestyle(int linestyleid, int mask)
{

    (*(dispdev->DefineLinestyle))(linestyleid, mask);

}

EXPORT void
SetLinestyle(int linestyleid)
{

    (*(dispdev->SetLinestyle))(linestyleid);

}

EXPORT void
SetColor(int colorid)
{

    (*(dispdev->SetColor))(colorid);

}

EXPORT void
Update()
{

    if (dispdev)
	    (*(dispdev->Update))();

}

static int
gen_ScreentoData(GRAPH *graph, int screenx, int screeny, double *x, double *y)
{

    double low, high;

    /* note: may want to cache datawindowsize/viewportsize */ /* done */

    /* note: think this out---Is 1 part of the viewport? Do we handle
        this correctly? */

    /* have to handle several types of grids */

    /* note: we can't compensate for X's demented y-coordinate system here
        since the grid routines use DrawLine w/o calling this routine */
    if ((graph->grid.gridtype == GRID_LOGLOG) ||
            (graph->grid.gridtype == GRID_YLOG)) {
      low = mylog10(graph->datawindow.ymin);
      high = mylog10(graph->datawindow.ymax);
      *y = pow(10, (screeny - 0.5 - graph->viewportyoff) * (high - low) /
          graph->viewport.height + low);
    } else {
      *y = (screeny - 0.5 - graph->viewportyoff) * graph->aspectratioy +
            graph->datawindow.ymin;
    }

    if ((graph->grid.gridtype == GRID_LOGLOG) ||
            (graph->grid.gridtype == GRID_XLOG)) {
      low = mylog10(graph->datawindow.xmin);
      high = mylog10(graph->datawindow.xmax);
      *x = pow(10, (screenx - 0.5 - graph->viewportxoff) * (high - low) /
          graph->viewport.width + low);
    } else {
      *x = (screenx - 0.5 - graph->viewportxoff) * graph->aspectratiox +
            graph->datawindow.xmin;
    }
return 0;
}

/* note: screen coordinates are relative to window
    so need to add viewport offsets */
static int
gen_DatatoScreen(GRAPH *graph, double x, double y, int *screenx, int *screeny)
{

    double low, high;

    /* note: may want to cache datawindowsize/viewportsize */ /* done */

    /* note: think this out---Is 1 part of the viewport? Do we handle
        this correctly? */

    /* have to handle several types of grids */

    /* note: we can't compensate for X's demented y-coordinate system here
        since the grid routines use DrawLine w/o calling this routine */
    if ((graph->grid.gridtype == GRID_LOGLOG) ||
            (graph->grid.gridtype == GRID_YLOG)) {
      low = mylog10(graph->datawindow.ymin);
      high = mylog10(graph->datawindow.ymax);
      *screeny = (mylog10(y) - low) / (high - low) * graph->viewport.height
	  + 0.5 + graph->viewportyoff;
    } else {
      *screeny = ((y - graph->datawindow.ymin) / graph->aspectratioy)
            + 0.5 + graph->viewportyoff;
    }

    if ((graph->grid.gridtype == GRID_LOGLOG) ||
            (graph->grid.gridtype == GRID_XLOG)) {
      low = mylog10(graph->datawindow.xmin);
      high = mylog10(graph->datawindow.xmax);
      *screenx = (mylog10(x) - low) / (high - low) * graph->viewport.width
            + 0.5 + graph ->viewportxoff;
    } else {
      *screenx = (x - graph->datawindow.xmin) / graph->aspectratiox
            + 0.5 + graph ->viewportxoff;
    }
return 0;
}

EXPORT int
ScreentoData(GRAPH *graph, int screenx, int screeny, double *x, double *y)
{

    (*(dispdev->ScreentoData))(graph, screenx, screeny, x, y);
    return 0;

}

EXPORT int
DatatoScreen(GRAPH *graph, double x, double y, int *screenx, int *screeny)
{

    (*(dispdev->DatatoScreen))(graph, x, y, screenx, screeny);
    return 0;

}

#ifdef notdef
/*
void NDCtoScreen(double x0, double y0, int *px, int *py)
{

    (*(dispdev->NDCtoScreen))(x0, y0, px, py);

}
*/
#endif

EXPORT int
Input(REQUEST *request, RESPONSE *response)
{

    (*(dispdev->Input))(request, response);
    return 0;

}

static int
gen_Input(REQUEST *request, RESPONSE *response)
{

    switch (request->option) {
      case char_option:
        response->reply.ch = inchar(request->fp);
        response->option = request->option;
        break;
      default:
        /* just ignore, since we don't want a million error messages */
	if (response)
	    response->option = error_option;
        break;
    }
    return 0;
}

/* no operation, do nothing */
static int nop()
{
    return(1);  /* so NewViewport will fail */
}

static int nodev()
{

    sprintf(ErrorMessage,
        "This operation is not defined for display type %s.",
        dispdev->name);
    internalerror(ErrorMessage);
    return(1);

}

EXPORT int
SaveText(GRAPH *graph, char *text, int x, int y)
{

    struct _keyed *keyed;

    keyed = (struct _keyed *) calloc(1, sizeof(struct _keyed));

    if (!graph->keyed) {
      graph->keyed = keyed;
    } else {
      keyed->next = graph->keyed;
      graph->keyed = keyed;
    }

    keyed->text = tmalloc(strlen(text) + 1);
    strcpy(keyed->text, text);

    keyed->x = x;
    keyed->y = y;

    keyed->colorindex = graph->currentcolor;
    return 0;
}

/* if given name of a hardcopy device, finds it and switches devices
   if given NULL, switches back */
EXPORT int
DevSwitch(char *devname)
{

    static DISPDEVICE *lastdev = NULL;

    if (devname != NULL) {
      if (lastdev != NULL) {
        internalerror("DevSwitch w/o changing back");
        return (1);
      }
      lastdev = dispdev;
      dispdev = FindDev(devname);
      if (!strcmp(dispdev->name, "error")) {
        internalerror("no hardcopy device");
        dispdev = lastdev;  /* undo */
        lastdev = NULL;
        return (1);
      }
      (*(dispdev->Init))();
    } else {
      (*(dispdev->Close))();
      dispdev = lastdev;
      lastdev = NULL;
    }
    return(0);

}
