
INP_COBJS = ifeval.o ifnewuid.o inp2b.o inp2c.o inp2d.o inp2dot.o \
            inp2e.o inp2f.o inp2g.o inp2h.o inp2i.o inp2j.o inp2k.o \
            inp2l.o inp2m.o inp2o.o inp2q.o inp2r.o inp2s.o inp2t.o \
            inp2u.o inp2v.o inp2w.o inp2z.o inpaname.o inpapnam.o \
            inpcfix.o inpdomod.o inpdoopt.o inpdpar.o inperrc.o \
            inperror.o inpeval.o inpfindl.o inpgmod.o inpgtitl.o \
            inpgtok.o inpgval.o inpkmods.o inplist.o inplkmod.o \
            inpmkmod.o inpmktmp.o inppas1.o inppas2.o inppname.o \
            inpptree.o inpsymt.o inptyplk.o ptfuncs.o sperror.o \
            inpgstr.o

INP_SRC_DIR     = src/lib/inp
INP_OBJ_DIR     = $(OBJS_DIR)/inp

INP_OBJ         = $(addprefix $(INP_OBJ_DIR)/,$(INP_COBJS))
INP_LIBRARY     = inp
INP_LIB         = $(OBJLIB_DIR)/lib$(INP_LIBRARY).a

inp: $(INP_LIB)

ifdef DLL
$(INP_LIB): lib$(INP_LIBRARY).dll

lib$(INP_LIBRARY).dll: $(INP_OBJ)
	@echo Creating DLL $@...
	$(CC) $(FLAGS) -shared -o $@ -Wl,--out-implib=$(INP_LIB) $^ \
   -Lobj/mingw/objlib -lmisc -lglobal

else
ifdef SO
$(INP_LIB): lib$(INP_LIBRARY).so

lib$(INP_LIBRARY).so: $(INP_OBJ)
	@echo Creating Shared Library $@...
	$(CC) $(FLAGS) -shared -o $@ $^

else
$(INP_LIB): $(INP_OBJ)
	@echo Archiving $@...
	$(AR) rcs $@ $^
endif
endif
   
$(INP_OBJ_DIR)/%.o: $(INP_SRC_DIR)/%.c
	@echo Compiling $<...
	$(CC) $(FLAGS) $(INCLUDE) -c $< -o $@

inp_clean:
	@echo Deleting inp library...
	$(RM) $(INP_LIB)
	$(RM) -r $(INP_OBJ)

