/**********
Copyright (c) 2003-2004 Paolo Fallucca.
**********/

#include "spice.h"

#ifdef HAS_MFB
#include "mfb.h"
#include <allegro.h>
#include "ftedev.h"
#include "ftedefs.h"
#include "ftegraph.h"
#include "mfbpc.h"

int cursor_enabled = 0;
extern DIALOG the_dialog[];
extern MENU cursor_menu[];

// Prototype
extern int redraw();

void cursor_init()
{
// Setting the mouse clickable region
the_dialog[CURSOR_POS].x = 0;
the_dialog[CURSOR_POS].y = menu_width + curr_plot * config.numypixels;
the_dialog[CURSOR_POS].w = config.numxpixels;
the_dialog[CURSOR_POS].h = config.numypixels;

// Enable get_cursor_pos
the_dialog[CURSOR_POS].flags = 0;

the_dialog[CURSOR_POS].proc(MSG_USER,&the_dialog[CURSOR_POS],0);
the_dialog[CURSOR_POS].proc(MSG_DRAW,&the_dialog[CURSOR_POS],0);
}

int cursor_enable()
{
cursor_init();
strcpy(cursor_menu[0].text,"&Disable");
cursor_menu[0].proc = cursor_disable;
cursor_enabled = 1;
return 0;
}

int cursor_disable()
{
the_dialog[CURSOR_POS].flags = D_HIDDEN;
strcpy(cursor_menu[0].text,"&Enable");
cursor_menu[0].proc = cursor_enable;
blit(bmp,plotsbmp,0,0,0,config.numypixels * curr_plot,
     config.numxpixels,config.numypixels);
redraw();
cursor_enabled = 0;
return 0;
}

int get_cursor_pos(int msg, DIALOG *d, int c)
{
//double x1,y1;
//double x2,y2;
//double difx,dify;
char c1str[40],c2str[40],difstr[40];
//SPICE_RECT legrect;
//char x1u,y1u,x2u,y2u,dxu,dyu;

switch (msg)
{
case MSG_USER:        // Initialize cursor position
get_cursor_init_pos();
break;

case MSG_DRAW:
draw_cursor();

// Find cursors positions
plot_curs_pos(c1str, c2str, difstr);

// Write a rect showing x,y positions
clear_to_color(curposbmp,bitmap_mask_color(curposbmp));
rect(curposbmp, 0, 0, curposbmp->w-1, curposbmp->h-1,3);
textout(curposbmp,font,c1str,10,10,3);
textout(curposbmp,font,c2str,10,20,3);
textout(curposbmp,font,difstr,10,30,3);
masked_blit(curposbmp,bmptmp,0,0,curr_dataplot->rgraph.x,
     curr_dataplot->rgraph.y + curr_dataplot->rgraph.h - curposbmp->h + 1 - menu_width,
     curposbmp->w, curposbmp->h);

blit(bmptmp,plotsbmp,0,0,0,config.numypixels * curr_plot,
     config.numxpixels,config.numypixels);     
redraw();
break;

case MSG_XCHAR:
if (!(key_shifts & KB_SHIFT_FLAG))
    {
    if((c>>8)==KEY_LEFT)
        {
        c1_screenx--;
        if ((c1_screenx > dataplot[curr_plot].rgraph.x - 1) &&
            (c1_screenx < dataplot[curr_plot].rgraph.x + dataplot[curr_plot].rgraph.w + 1))
            {
            Transform_coord(c1_screenx,c1_screeny,&c1_screenx,&c1_screeny,curr_plot);
            Find_cur_pos(&c1_screenx,&c1_screeny,&c1_xpos,&c1_ypos,c1_currtrace);
            the_dialog[CURSOR_POS].proc(MSG_DRAW,&the_dialog[CURSOR_POS],0);
            }
        else
            c1_screenx++;  // restore original position
        }
    if((c>>8)==KEY_RIGHT)
        {
        c1_screenx++;
        if ((c1_screenx > dataplot[curr_plot].rgraph.x - 1) &&
            (c1_screenx < dataplot[curr_plot].rgraph.x + dataplot[curr_plot].rgraph.w + 1))
            {
            Transform_coord(c1_screenx,c1_screeny,&c1_screenx,&c1_screeny,curr_plot);
            Find_cur_pos(&c1_screenx,&c1_screeny,&c1_xpos,&c1_ypos,c1_currtrace);
            the_dialog[CURSOR_POS].proc(MSG_DRAW,&the_dialog[CURSOR_POS],0);
            }
        else
            c1_screenx--;  // restore original position
        }
    }
else
    {
    if((c>>8)==KEY_LEFT)
        {
        c2_screenx--;
        if ((c2_screenx > dataplot[curr_plot].rgraph.x - 1) &&
            (c2_screenx < dataplot[curr_plot].rgraph.x + dataplot[curr_plot].rgraph.w + 1))
            {
            Transform_coord(c2_screenx,c2_screeny,&c2_screenx,&c2_screeny,curr_plot);
            Find_cur_pos(&c2_screenx,&c2_screeny,&c2_xpos,&c2_ypos,c2_currtrace);
            the_dialog[CURSOR_POS].proc(MSG_DRAW,&the_dialog[CURSOR_POS],0);
            }
        else
            c2_screenx++;  // restore original position
        }
    if((c>>8)==KEY_RIGHT)
        {
        c2_screenx++;
        if ((c2_screenx > dataplot[curr_plot].rgraph.x - 1) &&
            (c2_screenx < dataplot[curr_plot].rgraph.x + dataplot[curr_plot].rgraph.w + 1))
            {
            Transform_coord(c2_screenx,c2_screeny,&c2_screenx,&c2_screeny,curr_plot);
            Find_cur_pos(&c2_screenx,&c2_screeny,&c2_xpos,&c2_ypos,c2_currtrace);
            the_dialog[CURSOR_POS].proc(MSG_DRAW,&the_dialog[CURSOR_POS],0);
            }
        else
            c2_screenx--;  // restore original position
        }
    }
break;

case MSG_LPRESS:
Check_legend_click(mouse_x,mouse_y,&c1_currtrace,curr_plot);
if (Check_plot_click(mouse_x,mouse_y,curr_plot))
    Transform_coord(mouse_x,mouse_y,&c1_screenx,&c1_screeny,curr_plot);
Find_cur_pos(&c1_screenx,&c1_screeny,&c1_xpos,&c1_ypos,c1_currtrace);
the_dialog[CURSOR_POS].proc(MSG_DRAW,&the_dialog[CURSOR_POS],0);
break;

case MSG_RPRESS:
Check_legend_click(mouse_x,mouse_y,&c2_currtrace,curr_plot);
if (Check_plot_click(mouse_x,mouse_y,curr_plot))
    Transform_coord(mouse_x,mouse_y,&c2_screenx,&c2_screeny,curr_plot);
Find_cur_pos(&c2_screenx,&c2_screeny,&c2_xpos,&c2_ypos,c2_currtrace);
the_dialog[CURSOR_POS].proc(MSG_DRAW,&the_dialog[CURSOR_POS],0);
break;

}
return D_O_K;
}

#endif
