/**********
Copyright (c) 2003-2004 Paolo Fallucca.
**********/

#include "spice.h"
#ifdef HAS_MFB
#include "mfb.h"
#include <allegro.h>
#include "cpdefs.h"
#include "fteconst.h"
#include "ftedefs.h"
#include "ftegraph.h"
#include "ftedbgra.h"
#include "ftedev.h"
#include "mfbpc.h"
#include <math.h>
#include "datafile.h"
#include "menu.h"

#define MAXNUMPLOT 4
#define DIMSTRING 512
#define FG_COL 1
#define BG_COL 4

PLOT dataplot[MAXNUMPLOT];
PLOT* curr_dataplot;
struct dvec *first_d;

int num_plot;
int curr_plot;

char trace[DIMSTRING];
char xlo[20];
char xhi[20];
char ylo[20];
char yhi[20];

static int menu_on = 0;

extern DATAFILE *datafile;
extern int cursor_enabled;
extern void Replot(int plot);

MENU file_menu[] =
{
//    {"&Open..."   , load_rawfile, NULL, 0, NULL},
//    {"&Video Mode", set_video_mode, NULL, 0, NULL},
    {"E&xit"      , file_exit     , NULL, 0, NULL},
    {NULL, NULL, NULL, 0, NULL},
};

MENU trace_menu[] =
{
    {"&Add..."   ,    add_trace, NULL, 0, NULL},
    {"&Remove...", remove_trace, NULL, 0, NULL},
//    {"&Option...",       option, NULL, 0, NULL},
    {NULL, NULL, NULL, 0, NULL},
};

MENU plot_menu[] =
{
    {"&X Axis..."       ,        x_axis, NULL,          0, NULL},
    {"&Y Axis..."       ,        y_axis, NULL,          0, NULL},
    {"Grid..."          ,          grid, NULL,          0, NULL},
    {""                 ,          NULL, NULL,          0, NULL},
    {"&Add Plot"        ,      add_plot, NULL,          0, NULL},
    {"&Remove Plot"     ,   remove_plot, NULL,          0, NULL},
//    {"&Mark Data Points",   mark_points, NULL,          0, NULL},
//    {""                 ,          NULL, NULL,          0, NULL},
#define SEL_ANALISYS 8
//    {"&AC"              ,   ac_analysis, NULL, D_DISABLED, NULL},
//    {"&DC"              ,   dc_analysis, NULL, D_DISABLED, NULL},
//    {"&Transient"       , tran_analysis, NULL, D_DISABLED, NULL},
    {NULL, NULL, NULL, 0, NULL},
};

MENU zoom_menu[] =
{
    {"&Normal" ,  zoom_normal, NULL, 0, NULL},
    {    "&In" ,   zoom_in_en, NULL, 0, NULL},
    {   "&Out" ,  zoom_out_en, NULL, 0, NULL},
    {  "&Area" , zoom_area_en, NULL, 0, NULL},
    {NULL, NULL, NULL, 0, NULL},
};

MENU cursor_menu[] =
{
    {"&Enable " , cursor_enable, NULL, 0, NULL},
    {NULL, NULL, NULL, 0, NULL},
};

MENU help_menu[] =
{
    {"&About..."  , about, NULL, 0, NULL},
    {NULL, NULL, NULL, 0, NULL},
};

MENU main_menu[] =
{
    {"&File"   , NULL,    file_menu,  0, NULL},
    {"&Trace"  , NULL,   trace_menu,  0, NULL},
    {"&Plot"   , NULL,    plot_menu,  0, NULL},
    {"&Zoom"   , NULL,    zoom_menu,  0, NULL},
    {"&Cursor" , NULL,  cursor_menu,  0, NULL},
    {"&Help"   , NULL,    help_menu,  0, NULL},
    {NULL, NULL, NULL, 0, NULL},
};

DIALOG the_dialog[] =
{
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)     (d1)   (d2)     (dp) */
   {     d_menu_proc,    0,    0,    0,    0,   255,    0,    0,      1,        0,      0,    main_menu },

//#define ZOOM_IN 1
   {         zoom_in,    0,    0,    0,    0,   255,    0,    0, D_DISABLED,    0,      0,    NULL },
//#define ZOOM_OUT 2
   {        zoom_out,    0,    0,    0,    0,   255,    0,    0, D_DISABLED,    0,      0,    NULL },
//#define ZOOM_AREA 3
   {       zoom_area,    0,    0,    0,    0,   255,    0,    0, D_DISABLED,    0,      0,    NULL },

//#define CURSOR_POS 4
   {  get_cursor_pos,    0,    0,    0,    0,   255,    0,    0,   D_HIDDEN,    0,      0,    NULL },
//#define SEL_PLOT 5
   {     select_plot,    0,    0,    0,    0,   255,    0,    0,      1,    	0,      0,    NULL },
   // keyboard shortcuts
   { d_keyboard_proc, 0, 0, 0, 0, 0, 0, 0, 0, KEY_F12, 0, screen_shot },
   {            NULL,    0,    0,    0,    0,     0,    0,    0,      0,        0,      0,    NULL }
};

DIALOG trace_dialog[] =
{
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)   (bg)  (key) (flags)  (d1)  (d2)     (dp) */
   { d_shadow_box_proc,   0,    0,  169,  118, FG_COL, BG_COL, 0,    0,      0,    0,    NULL },
   { d_box_proc,          0,    0,  168,   13, FG_COL, BG_COL, 0,    0,      0,    0,    NULL },
#define TEXT_TITLE 2
   { d_text_proc,         3,    3,    1,    1, FG_COL, BG_COL, 0,    0,      0,    0,    "" },

   { d_text_proc,         3,   29,    1,    1, FG_COL, BG_COL, 0,    0,      0,    0,    "Trace" },
   { d_box_proc,         52,   26,  111,   13, FG_COL, BG_COL, 0,    0,      0,    0,    NULL },
#define EDIT_PROC 5
   { d_edit_proc,        57,   29,  103,   50, FG_COL, BG_COL, 0,    0,  sizeof(trace),    0,   trace },
#define LIST_PROC 6
   { NULL,               14,   40,  140,   45, FG_COL, BG_COL, 0,   D_EXIT,  0,    0,    NULL },

#define TRACE_BUTT1 7
   { button_dp2_proc,    14,   91,   52,   18, FG_COL, BG_COL, 0,   D_EXIT,  0,    0,    "Ok",add_trace_ok },
   { button_dp2_proc,   102,   91,   52,   18, FG_COL, BG_COL, 0,   D_EXIT,  0,    0,    "Cancel",cancel },

   { NULL,                0,    0,    0,    0,    0,    0,     0,    0,      0,    0,    NULL }
};

DIALOG x_axis_dialog[] =
{
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)   (bg)  (key) (flags)  (d1)  (d2)     (dp) */
   { d_shadow_box_proc,   0,    0,  169,  155, FG_COL, BG_COL, 0,    0,      0,    0,     NULL },
   { d_box_proc,          0,    0,  168,   13, FG_COL, BG_COL, 0,    0,      0,    0,     NULL },
   { d_text_proc,         3,    3,    1,    1, FG_COL, BG_COL, 0,    0,      0,    0,     "X Axis Settings..." },

   { d_box_proc,          9,   22,  151,   50, FG_COL, BG_COL, 0,    0,      0,    0,     NULL },
   { d_text_proc,        17,   18,    8,    8, FG_COL, BG_COL, 0,    0,      0,    0,     "Data Range" },
#define AUTO_RANGE_RADIO_BUTT 5
   { d_radio_proc,       12,   30,    8,    8, FG_COL, BG_COL, 0,    0,      0,    0,     "Auto Range" },
#define USER_DEF_RADIO_BUTT 6
   { d_radio_proc,       12,   42,    8,    8, FG_COL, BG_COL, 0,    0,      0,    0,     "User Defined" },
   { d_box_proc,         12,   53,   50,   13, FG_COL, BG_COL, 0,    0,      0,    0,     NULL },
#define EDIT_XLO 8
   { d_edit_proc,        17,   56,   42,   50, FG_COL, BG_COL, 0, D_DISABLED,  sizeof(xlo),     0,   xlo },
   { d_box_proc,         67,   53,   50,   13, FG_COL, BG_COL, 0,    0,      0,    0,     NULL },
#define EDIT_XHI 10
   { d_edit_proc,        72,   56,   42,   50, FG_COL, BG_COL, 0, D_DISABLED,  sizeof(xhi),     0,   xhi },

   { d_box_proc,          9,   84,  151,   36, FG_COL, BG_COL, 0,    0,      0,    0,     NULL },
   { d_text_proc,        17,   80,    8,    8, FG_COL, BG_COL, 0,    0,      0,    0,     "Scale" },
#define LIN_RADIO_BUTT 13
   { d_radio_proc,       12,   92,    8,    8, FG_COL, BG_COL, 0,    0,      1,    0,     "Linear" },
#define LOG_RADIO_BUTT 14
   { d_radio_proc,       12,  104,    8,    8, FG_COL, BG_COL, 0,    0,      1,    0,     "Log" },

   { x_axis_proc,         0,    0,    0,    0,   255,    0,    0,    0,    0,      0,    NULL },
   { button_dp2_proc,    14,  127,   52,   18, FG_COL, BG_COL, 0,   D_EXIT,  0,    0,     "Ok"    , x_axis_set_ok },
   { button_dp2_proc,   102,  127,   52,   18, FG_COL, BG_COL, 0,   D_EXIT,  0,    0,     "Cancel", cancel },

   { NULL,                0,    0,    0,    0,    0,    0,     0,    0,      0,    0,     NULL }
};

DIALOG y_axis_dialog[] =
{
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)   (bg)  (key) (flags)  (d1)  (d2)     (dp) */
   { d_shadow_box_proc,   0,    0,  169,  155, FG_COL, BG_COL, 0,    0,      0,    0,     NULL },
   { d_box_proc,          0,    0,  168,   13, FG_COL, BG_COL, 0,    0,      0,    0,     NULL },
   { d_text_proc,         3,    3,    1,    1, FG_COL, BG_COL, 0,    0,      0,    0,     "Y Axis Settings..." },

   { d_box_proc,          9,   22,  151,   50, FG_COL, BG_COL, 0,    0,      0,    0,     NULL },
   { d_text_proc,        17,   18,    8,    8, FG_COL, BG_COL, 0,    0,      0,    0,     "Data Range" },
#define AUTO_RANGE_RADIO_BUTT 5
   { d_radio_proc,       12,   30,    8,    8, FG_COL, BG_COL, 0,    0,      0,    0,     "Auto Range" },
#define USER_DEF_RADIO_BUTT 6
   { d_radio_proc,       12,   42,    8,    8, FG_COL, BG_COL, 0,    0,      0,    0,     "User Defined" },
   { d_box_proc,         12,   53,   50,   13, FG_COL, BG_COL, 0,    0,      0,    0,     NULL },
#define EDIT_YLO 8
   { d_edit_proc,        17,   56,   42,   50, FG_COL, BG_COL, 0, D_DISABLED,  sizeof(ylo),     0,   ylo },
   { d_box_proc,         67,   53,   50,   13, FG_COL, BG_COL, 0,    0,      0,    0,     NULL },
#define EDIT_YHI 10
   { d_edit_proc,        72,   56,   42,   50, FG_COL, BG_COL, 0, D_DISABLED,  sizeof(yhi),     0,   yhi },

   { d_box_proc,          9,   84,  151,   36, FG_COL, BG_COL, 0,    0,      0,    0,     NULL },
   { d_text_proc,        17,   80,    8,    8, FG_COL, BG_COL, 0,    0,      0,    0,     "Scale" },
#define LIN_RADIO_BUTT 13
   { d_radio_proc,       12,   92,    8,    8, FG_COL, BG_COL, 0,    0,      1,    0,     "Linear" },
#define LOG_RADIO_BUTT 14
   { d_radio_proc,       12,  104,    8,    8, FG_COL, BG_COL, 0,    0,      1,    0,     "Log" },

   { y_axis_proc,         0,    0,    0,    0,   255,    0,    0,    0,    0,      0,    NULL },
   { button_dp2_proc,    14,  127,   52,   18, FG_COL, BG_COL, 0,   D_EXIT,  0,    0,     "Ok"    , y_axis_set_ok },
   { button_dp2_proc,   102,  127,   52,   18, FG_COL, BG_COL, 0,   D_EXIT,  0,    0,     "Cancel", cancel },

   { NULL,                0,    0,    0,    0,    0,    0,     0,    0,      0,    0,     NULL }
};

DIALOG grid_dialog[] =
{
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)   (bg)  (key) (flags)  (d1)  (d2)     (dp) */
   { d_shadow_box_proc,   0,    0,  169,  118, FG_COL, BG_COL, 0,    0,       0,    0,    NULL },
   { d_box_proc,          0,    0,  168,   13, FG_COL, BG_COL, 0,    0,       0,    0,    NULL },
   { d_text_proc,         3,    3,    1,    1, FG_COL, BG_COL, 0,    0,       0,    0,    "Grid Setting" },
#define DEFAULT_RADIO_BUTT 3
   { d_radio_proc,        6,   18,    8,    8, FG_COL, BG_COL, 0, D_SELECTED, 1,    0,    "Default" },
#define POLAR_RADIO_BUTT 4
   { d_radio_proc,        6,   30,    8,    8, FG_COL, BG_COL, 0,    0,       1,    0,    "Polar" },
#define SMITH_RADIO_BUTT 5
   { d_radio_proc,        6,   42,    8,    8, FG_COL, BG_COL, 0,    0,       1,    0,    "Smith" },
#define SMITHGRID_RADIO_BUTT 6
   { d_radio_proc,        6,   54,    8,    8, FG_COL, BG_COL, 0,    0,       1,    0,    "SmithGrid" },
   { button_dp2_proc,    14,   91,   52,   18, FG_COL, BG_COL, 0,   D_EXIT,   0,    0,    "Ok",     grid_set_ok },
   { button_dp2_proc,   102,   91,   52,   18, FG_COL, BG_COL, 0,   D_EXIT,   0,    0,    "Cancel", cancel },
   { NULL,                0,    0,    0,    0,    0,    0,     0,    0,       0,    0,    NULL }
};

DIALOG about_dialog[] =
{
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)   (bg)  (key) (flags)  (d1)  (d2)     (dp) */
   { d_shadow_box_proc,   0,    0,  169,  118, FG_COL,  0,     0,    0,      0,    0,    NULL },
   { d_box_proc,          0,    0,  168,   13, FG_COL, BG_COL, 0,    0,      0,    0,    NULL },
   { d_text_proc,         3,    3,    1,    1, FG_COL, BG_COL, 0,    0,      0,    0,    "About" },
#define LOGO_BMP 3
   { d_bitmap_proc,      30,   13,  140,   70,    3,    4,     0,    0,      0,    0,    NULL },
#define TEXT_VERS 4
   { d_text_proc,        70,   55,    1,    1, FG_COL,  0,     0,    0,      0,    0,    "" },
   { d_text_proc,        14,   65,    1,    1, FG_COL,  0,     0,    0,      0,    0,    "(c) Paolo Fallucca" },
#define OK_BUTT 6
   { button_dp2_proc,    56,   80,   52,   18, FG_COL, BG_COL, 0,   D_EXIT,  0,    0,    "Ok",cancel },
   { NULL,                0,    0,    0,    0,    0,    0,     0,    0,      0,    0,    NULL }
};

int iCurrXRange = AUTO_RANGE_RADIO_BUTT;
int iCurrYRange = AUTO_RANGE_RADIO_BUTT;

int screen_shot()
{
save_pcx("image.pcx",plotsbmp,pal);
return 0;
}

int x_axis_proc(int msg, DIALOG *d, int c)
{
switch (msg)
{
case MSG_RADIO:
if (c == 0) // Group 0 selected (Data Range)
    {
    if ((x_axis_dialog[AUTO_RANGE_RADIO_BUTT].flags == 12) ||
        (x_axis_dialog[AUTO_RANGE_RADIO_BUTT].flags == 4))
        {
        x_axis_dialog[EDIT_XLO].flags = D_DISABLED;
        x_axis_dialog[EDIT_XHI].flags = D_DISABLED;
        }
    else if ((x_axis_dialog[USER_DEF_RADIO_BUTT].flags == 12) ||
        (x_axis_dialog[USER_DEF_RADIO_BUTT].flags == 4))
        {
        x_axis_dialog[EDIT_XLO].flags = 0;
        x_axis_dialog[EDIT_XHI].flags = 0;
        }
    
    show_mouse(NULL);
    x_axis_dialog[EDIT_XLO].proc(MSG_DRAW,&x_axis_dialog[EDIT_XLO],0);
    x_axis_dialog[EDIT_XHI].proc(MSG_DRAW,&x_axis_dialog[EDIT_XHI],0);
    show_mouse(screen);
    }
break;
}
return D_O_K;
}

int y_axis_proc(int msg, DIALOG *d, int c)
{
switch (msg)
{
case MSG_RADIO:
if (c == 0) // Group 0 selected (Data Range)
    {
    if ((y_axis_dialog[AUTO_RANGE_RADIO_BUTT].flags == 12) ||
        (y_axis_dialog[AUTO_RANGE_RADIO_BUTT].flags == 4))
        {
        y_axis_dialog[EDIT_YLO].flags = D_DISABLED;
        y_axis_dialog[EDIT_YHI].flags = D_DISABLED;
        }
    else if ((y_axis_dialog[USER_DEF_RADIO_BUTT].flags == 12) ||
        (y_axis_dialog[USER_DEF_RADIO_BUTT].flags == 4))
        {
        y_axis_dialog[EDIT_YLO].flags = 0;
        y_axis_dialog[EDIT_YHI].flags = 0;
        }
    
    show_mouse(NULL);
    y_axis_dialog[EDIT_YLO].proc(MSG_DRAW,&y_axis_dialog[EDIT_YLO],0);
    y_axis_dialog[EDIT_YHI].proc(MSG_DRAW,&y_axis_dialog[EDIT_YHI],0);
    show_mouse(screen);
    }
break;
}
return D_O_K;
}

int select_plot(int msg, DIALOG *d, int c)
{

switch (msg)
{
case MSG_USER:        // Initialize active plot
break;

case MSG_LPRESS:
select_plot_lpress();
break;

case MSG_RPRESS:
redraw();
if (the_dialog[CURSOR_POS].flags == 0)  // cursor enabled
    the_dialog[CURSOR_POS].proc(MSG_RPRESS,&the_dialog[CURSOR_POS],0);
break;
}

return D_O_K;
}

int zoom_in(int msg, DIALOG *d, int c)
{
int x0,y0;
int x,y,w,h;
double x1,y1;
double x2,y2;

switch (msg)
{
case MSG_START:
// Put in bmp che current plot taken from plotsbmp
blit(plotsbmp,bmp,0,config.numypixels * curr_plot,0,0,
     config.numxpixels,config.numypixels);
break;

case MSG_LPRESS:
x0 = mouse_x - curr_dataplot->rgraph.x;
y0 = mouse_y - curr_dataplot->rgraph.y - config.numypixels * curr_plot;

x = x0 - curr_dataplot->rgraph.w/4;
w = x0 + curr_dataplot->rgraph.w/4;
y = y0 + curr_dataplot->rgraph.h/4;
h = y0 - curr_dataplot->rgraph.h/4;

ScreentoData(curr_dataplot->graphic,x+curr_dataplot->rgraph.x,
             config.numypixels -(y+curr_dataplot->rgraph.y-menu_width),&x1,&y1);
ScreentoData(curr_dataplot->graphic,w+curr_dataplot->rgraph.x,
             config.numypixels -(h+curr_dataplot->rgraph.y-menu_width),&x2,&y2);

set_x_limits = 1;
plotparam.xlo = x1;
plotparam.xhi = x2;
set_y_limits = 1;
plotparam.ylo = y1;
plotparam.yhi = y2;
Replot(curr_plot);
redraw();

// Disable zoom_in
the_dialog[ZOOM_IN].flags = D_HIDDEN;
// Set the initial mouse pointer
set_mouse_sprite(NULL);
break;

case MSG_XCHAR:
if((c>>8)==KEY_ESC)
    {
    // Disable zoom_in
    the_dialog[ZOOM_IN].flags = D_HIDDEN;
    // Set the initial mouse pointer
    set_mouse_sprite(NULL);
    return D_USED_CHAR;
    }
}
return D_O_K;
}

int zoom_out(int msg, DIALOG *d, int c)
{
int x0,y0;
int x,y,w,h;
double x1,y1;
double x2,y2;

switch (msg)
{
case MSG_START:
// Put in bmp che current plot taken from plotsbmp
blit(plotsbmp,bmp,0,config.numypixels * curr_plot,0,0,
     config.numxpixels,config.numypixels);
break;

case MSG_LPRESS:
x0 = mouse_x - curr_dataplot->rgraph.x;
y0 = mouse_y - curr_dataplot->rgraph.y - config.numypixels * curr_plot;

x = x0 - curr_dataplot->rgraph.w;
w = x0 + curr_dataplot->rgraph.w;
y = y0 + curr_dataplot->rgraph.h;
h = y0 - curr_dataplot->rgraph.h;

ScreentoData(curr_dataplot->graphic,x+curr_dataplot->rgraph.x,
             config.numypixels -(y+curr_dataplot->rgraph.y-menu_width),&x1,&y1);
ScreentoData(curr_dataplot->graphic,w+curr_dataplot->rgraph.x,
             config.numypixels -(h+curr_dataplot->rgraph.y-menu_width),&x2,&y2);

set_x_limits = 1;
plotparam.xlo = x1;
plotparam.xhi = x2;
set_y_limits = 1;
plotparam.ylo = y1;
plotparam.yhi = y2;
Replot(curr_plot);
redraw();

// Disable zoom_out
the_dialog[ZOOM_OUT].flags = D_HIDDEN;
// Set the initial mouse pointer
set_mouse_sprite(NULL);
break;

case MSG_XCHAR:
if((c>>8)==KEY_ESC)
    {
    // Disable zoom_out
    the_dialog[ZOOM_OUT].flags = D_HIDDEN;
    // Set the initial mouse pointer
    set_mouse_sprite(NULL);
    return D_USED_CHAR;
    }
}
return D_O_K;
}

int zoom_area(int msg, DIALOG *d, int c)
{
int x,y,w,h;
double x1,y1;
double x2,y2;

switch (msg)
{
case MSG_START:
// Put in bmp che current plot taken from plotsbmp
blit(plotsbmp,bmp,0,config.numypixels * curr_plot,0,0,
     config.numxpixels,config.numypixels);
break;

case MSG_LPRESS:
x = mouse_x - curr_dataplot->rgraph.x;
y = mouse_y - curr_dataplot->rgraph.y - config.numypixels * curr_plot;
w = x;
h = y;

show_mouse(NULL);
while(mouse_b & 1)
    {
    blit(bmp,bmptmp,curr_dataplot->rgraph.x,curr_dataplot->rgraph.y - menu_width,
         0,0,curr_dataplot->rgraph.w+1,curr_dataplot->rgraph.h+1);
    rect(bmptmp,x,y,w,h,5);
    blit(bmptmp,screen,0,0,curr_dataplot->rgraph.x,curr_dataplot->rgraph.y + config.numypixels * curr_plot,
         curr_dataplot->rgraph.w+1,curr_dataplot->rgraph.h+1);
    w = mouse_x - curr_dataplot->rgraph.x;
    h = mouse_y - curr_dataplot->rgraph.y - config.numypixels * curr_plot;
        if (w < 0)
           w = 0;
        else if (w > curr_dataplot->rgraph.w)
           w = curr_dataplot->rgraph.w;
        if (h < 0)
           h = 0;
        else if (h > curr_dataplot->rgraph.h)
           h = curr_dataplot->rgraph.h;
    }

/*rect(bmp, x+curr_dataplot->rgraph.x, y+curr_dataplot->rgraph.y-menu_width,
     w+curr_dataplot->rgraph.x, h+curr_dataplot->rgraph.y-menu_width, 5);
blit(bmp,screen,0,0,0,menu_width,config.numxpixels,config.numypixels);*/

ScreentoData(curr_dataplot->graphic,x+curr_dataplot->rgraph.x,
             config.numypixels -(y+curr_dataplot->rgraph.y-menu_width),&x1,&y1);
ScreentoData(curr_dataplot->graphic,w+curr_dataplot->rgraph.x,
             config.numypixels -(h+curr_dataplot->rgraph.y-menu_width),&x2,&y2);
set_x_limits = 1;
plotparam.xlo = MIN(x1,x2);
plotparam.xhi = MAX(x1,x2);
set_y_limits = 1;
plotparam.ylo = MIN(y1,y2);
plotparam.yhi = MAX(y1,y2);
Replot(curr_plot);
redraw();

// Disable zoom_area
the_dialog[ZOOM_AREA].flags = D_HIDDEN;
// Set the initial mouse pointer
set_mouse_sprite(NULL);
break;

case MSG_XCHAR:
if((c>>8)==KEY_ESC)
    {
    // Disable zoom_area
    the_dialog[ZOOM_AREA].flags = D_HIDDEN;
    // Set the initial mouse pointer
    set_mouse_sprite(NULL);
    return D_USED_CHAR;
    }
}
return D_O_K;
}

void redraw()
{
show_mouse(NULL);
blit(plotsbmp,screen,0,0,0,menu_width,mfbpc_width,mfbpc_height-menu_width);
if (num_plot > 1)
    circlefill(screen,curr_dataplot->rgraph.x + curr_dataplot->rgraph.w + 5,curr_dataplot->rgraph.y + config.numypixels * curr_plot + curr_dataplot->rgraph.h / 2,3,5);
show_mouse(screen);
}

int x_axis()
{
if (iCurrXRange == AUTO_RANGE_RADIO_BUTT)
    {
    x_axis_dialog[AUTO_RANGE_RADIO_BUTT].flags = D_SELECTED;
    x_axis_dialog[USER_DEF_RADIO_BUTT].flags = 0;
    }
else if (iCurrXRange == USER_DEF_RADIO_BUTT)
    {
    x_axis_dialog[USER_DEF_RADIO_BUTT].flags = D_SELECTED;
    x_axis_dialog[AUTO_RANGE_RADIO_BUTT].flags = 0;
    }

if ((plotparam.gtype == GRID_LIN) || (plotparam.gtype == GRID_YLOG))
    {
    x_axis_dialog[LIN_RADIO_BUTT].flags = D_SELECTED;
    x_axis_dialog[LOG_RADIO_BUTT].flags = 0;
    }
else if ((plotparam.gtype == GRID_XLOG) || (plotparam.gtype == GRID_LOGLOG))
    {
    x_axis_dialog[LOG_RADIO_BUTT].flags = D_SELECTED;
    x_axis_dialog[LIN_RADIO_BUTT].flags = 0;
    }

centre_dialog(x_axis_dialog);
popup_dialog(x_axis_dialog,-1);
redraw();
return D_O_K;
}

int y_axis()
{
if (iCurrYRange == AUTO_RANGE_RADIO_BUTT)
    {
    y_axis_dialog[AUTO_RANGE_RADIO_BUTT].flags = D_SELECTED;
    y_axis_dialog[USER_DEF_RADIO_BUTT].flags = 0;
    }
else if (iCurrYRange == USER_DEF_RADIO_BUTT)
    {
    y_axis_dialog[USER_DEF_RADIO_BUTT].flags = D_SELECTED;
    y_axis_dialog[AUTO_RANGE_RADIO_BUTT].flags = 0;
    }

if ((plotparam.gtype == GRID_LIN) || (plotparam.gtype == GRID_XLOG))
    {
    y_axis_dialog[LIN_RADIO_BUTT].flags = D_SELECTED;
    y_axis_dialog[LOG_RADIO_BUTT].flags = 0;
    }
else if ((plotparam.gtype == GRID_YLOG) || (plotparam.gtype == GRID_LOGLOG))
    {
    y_axis_dialog[LOG_RADIO_BUTT].flags = D_SELECTED;
    y_axis_dialog[LIN_RADIO_BUTT].flags = 0;
    }

centre_dialog(y_axis_dialog);
popup_dialog(y_axis_dialog,-1);
redraw();
return D_O_K;
}

int grid()
{
centre_dialog(grid_dialog);
popup_dialog(grid_dialog,-1);
redraw();
return D_O_K;
}

void clear_traces()
{
//wordlist **wl, *nw;
int i;

for (i = 0; i < num_plot; i++)
    {
    // Free all memory allocated for tracelist for every plot
    //wl_free(&(dataplot[i].tracelist));
    free_tracelist(&(dataplot[i].tracelist));

    // Reset trace number
    dataplot[i].ntrace = 0;
    }

// Reset plot number to 1
config.numypixels = mfbpc_height - menu_width;
dispdev->height = config.numypixels + 1;
num_plot = 1;
curr_plot = 0;
curr_dataplot = &dataplot[0];
}

int ac_analysis()
{
plot_menu[SEL_ANALISYS].flags |=  D_SELECTED;
plot_menu[SEL_ANALISYS+1].flags &= ~D_SELECTED;
plot_menu[SEL_ANALISYS+2].flags &= ~D_SELECTED;
plot_setcur("ac");

clear_traces();
clear_to_color(plotsbmp,0);
redraw();
return 0;
}

int dc_analysis()
{
plot_menu[SEL_ANALISYS].flags &= ~D_SELECTED;
plot_menu[SEL_ANALISYS+1].flags |=  D_SELECTED;
plot_menu[SEL_ANALISYS+2].flags &= ~D_SELECTED;
plot_setcur("dc");

clear_traces();
clear_to_color(plotsbmp,0);
redraw();
return 0;
}

int tran_analysis()
{
plot_menu[SEL_ANALISYS].flags &= ~D_SELECTED;
plot_menu[SEL_ANALISYS+1].flags &= ~D_SELECTED;
plot_menu[SEL_ANALISYS+2].flags |=  D_SELECTED;
plot_setcur("tran");

clear_traces();
clear_to_color(plotsbmp,0);
redraw();
return 0;
}

int mark_points()
{
int screenx,screeny,i;
double x,y;
struct dvec *v = NULL, *xs;
struct pnode *names,*n;
GRIDTYPE gridtype;
    
// Put in bmp che current plot taken from plotsbmp
blit(plotsbmp,bmp,0,config.numypixels * curr_plot,0,0,
     config.numxpixels,config.numypixels);
blit(bmp,bmptmp,0,0,0,0,config.numxpixels,config.numypixels);

// Evaluate the vector.
names = ft_getpnames(curr_dataplot->tracelist, true);
for (n = names; n; n = n->pn_next)
    {
    v = ft_evaluate(n);

    // Now fill in the scale.
    if (!v->v_scale)
       {
       if (v->v_plot->pl_scale)
           v->v_scale = v->v_plot->pl_scale;
       else
           v->v_scale = v;
       }

    gridtype = (curr_dataplot->graphic)->grid.gridtype;
    if (gridtype == GRID_POLAR)
        (struct dvec *) xs = NULL;
    else
        xs = v->v_scale;

    if(!xs)
    for (i = 0; i < v->v_length; i++)
        {
        x = isreal(xs) ? v->v_realdata[i] : realpart(&v->v_compdata[i]);
        y = isreal(v) ? v->v_realdata[i] : imagpart(&v->v_compdata[i]);
        DatatoScreen(curr_dataplot->graphic,x,y,&screenx,&screeny);
        circlefill(bmptmp,screenx,config.numypixels - screeny,1,20);
        }
    else
    for (i = 0; i < v->v_length; i++)
        {
        x = isreal(xs) ? xs->v_realdata[i] : realpart(&xs->v_compdata[i]);
        y = isreal(v) ? v->v_realdata[i] : realpart(&v->v_compdata[i]);
        DatatoScreen(curr_dataplot->graphic,x,y,&screenx,&screeny);
        circlefill(bmptmp,screenx,config.numypixels - screeny,1,20);
        }
    }
blit(bmptmp,plotsbmp,0,0,0,config.numypixels * curr_plot,
     config.numxpixels,config.numypixels);
redraw();
return 0;
}

int zoom_normal()
{
/*clear_to_color(bmp,0);
//gr_resize(currentgraph);
gr_redrawgrid(currentgraph);
//ft_graf(first_d, first_d->v_scale, false);
show_mouse(NULL);
blit(bmp,screen,0,0,0,menu_width,mfbpc_width,mfbpc_height-menu_width);
show_mouse(screen);*/

set_x_limits = 0;
set_y_limits = 0;
Replot(curr_plot);
redraw();
return 0;
}

void zoom_init(int dlgnum)
{
// Change mouse shape and focus
show_mouse(NULL);
set_mouse_sprite(cross_mouse);
set_mouse_sprite_focus(5,5);
show_mouse(screen);

// Disable cursor
the_dialog[CURSOR_POS].flags = D_HIDDEN;

// Setting the mouse clickable region
the_dialog[dlgnum].x = curr_dataplot->rgraph.x;
the_dialog[dlgnum].y = curr_dataplot->rgraph.y + config.numypixels * curr_plot;
the_dialog[dlgnum].w = curr_dataplot->rgraph.w;
the_dialog[dlgnum].h = curr_dataplot->rgraph.h;

// Enable zoom procedure
the_dialog[dlgnum].flags = 0;
}

int zoom_in_en()
{
zoom_init(ZOOM_IN);
return 0;
}

int zoom_out_en()
{
zoom_init(ZOOM_OUT);
return 0;
}

int zoom_area_en()
{
zoom_init(ZOOM_AREA);
return 0;
}

int d_my_add_list_proc(int msg, DIALOG *d, int c)
{
int retval;
int *size = NULL;

retval = d_list_proc(msg, d, c);
if ((msg == MSG_START) || (msg == MSG_CLICK))
   {
   strcpy(trace, add_trace_list(trace_dialog[LIST_PROC].d1,size));
   trace_dialog[EDIT_PROC].proc(MSG_DRAW, &trace_dialog[EDIT_PROC], 0);
   }
if (msg == MSG_DCLICK)
   {
   add_trace_ok();
   }
return retval;
}

int d_my_rem_list_proc(int msg, DIALOG *d, int c)
{
int retval;
int *size = NULL;

retval = d_list_proc(msg, d, c);
if ((msg == MSG_START) || (msg == MSG_CLICK))
   {
   strcpy(trace, remove_trace_list(trace_dialog[LIST_PROC].d1,size));
   trace_dialog[EDIT_PROC].proc(MSG_DRAW, &trace_dialog[EDIT_PROC], 0);
   }
if (msg == MSG_DCLICK)
   {
   remove_trace_ok();
   }
return retval;
}

int x_axis_set_ok()
{
int i;

set_x_limits = 0;

if (x_axis_dialog[USER_DEF_RADIO_BUTT].flags == D_SELECTED)
    iCurrXRange = USER_DEF_RADIO_BUTT;
if (x_axis_dialog[AUTO_RANGE_RADIO_BUTT].flags == D_SELECTED)
    iCurrXRange = AUTO_RANGE_RADIO_BUTT;

if ((x_axis_dialog[LIN_RADIO_BUTT].flags == D_SELECTED) &&
    (y_axis_dialog[LIN_RADIO_BUTT].flags == D_SELECTED))
    plotparam.gtype = GRID_LIN;

if ((x_axis_dialog[LOG_RADIO_BUTT].flags == D_SELECTED) &&
    (y_axis_dialog[LIN_RADIO_BUTT].flags == D_SELECTED))
    plotparam.gtype = GRID_XLOG;

if ((x_axis_dialog[LIN_RADIO_BUTT].flags == D_SELECTED) &&
    (y_axis_dialog[LOG_RADIO_BUTT].flags == D_SELECTED))
    plotparam.gtype = GRID_YLOG;

if ((x_axis_dialog[LOG_RADIO_BUTT].flags == D_SELECTED) &&
    (y_axis_dialog[LOG_RADIO_BUTT].flags == D_SELECTED))
    plotparam.gtype = GRID_LOGLOG;

if (x_axis_dialog[USER_DEF_RADIO_BUTT].flags == D_SELECTED)
    {
    set_x_limits = 1;
    plotparam.xlo = uatof(xlo);
    plotparam.xhi = uatof(xhi);
    }

for (i = 0; i < num_plot; i++)
    Replot(i);

return D_EXIT;
}

int y_axis_set_ok()
{
int i;

set_y_limits = 0;

if (y_axis_dialog[USER_DEF_RADIO_BUTT].flags == D_SELECTED)
    iCurrYRange = USER_DEF_RADIO_BUTT;
if (y_axis_dialog[AUTO_RANGE_RADIO_BUTT].flags == D_SELECTED)
    iCurrYRange = AUTO_RANGE_RADIO_BUTT;

if ((x_axis_dialog[LIN_RADIO_BUTT].flags == D_SELECTED) &&
    (y_axis_dialog[LIN_RADIO_BUTT].flags == D_SELECTED))
    plotparam.gtype = GRID_LIN;

if ((x_axis_dialog[LOG_RADIO_BUTT].flags == D_SELECTED) &&
    (y_axis_dialog[LIN_RADIO_BUTT].flags == D_SELECTED))
    plotparam.gtype = GRID_XLOG;

if ((x_axis_dialog[LIN_RADIO_BUTT].flags == D_SELECTED) &&
    (y_axis_dialog[LOG_RADIO_BUTT].flags == D_SELECTED))
    plotparam.gtype = GRID_YLOG;

if ((x_axis_dialog[LOG_RADIO_BUTT].flags == D_SELECTED) &&
    (y_axis_dialog[LOG_RADIO_BUTT].flags == D_SELECTED))
    plotparam.gtype = GRID_LOGLOG;

if (y_axis_dialog[USER_DEF_RADIO_BUTT].flags == D_SELECTED)
    {
    set_y_limits = 1;
    plotparam.ylo = uatof(ylo);
    plotparam.yhi = uatof(yhi);
    }

for (i = 0; i < num_plot; i++)
    Replot(i);

return D_EXIT;
}

int grid_set_ok()
{
int i;

if (grid_dialog[DEFAULT_RADIO_BUTT].flags == D_SELECTED)
    plotparam.gtype = GRID_NONE;
if (grid_dialog[POLAR_RADIO_BUTT].flags == D_SELECTED)
    plotparam.gtype = GRID_POLAR;
if (grid_dialog[SMITH_RADIO_BUTT].flags == D_SELECTED)
    plotparam.gtype = GRID_SMITH;
if (grid_dialog[SMITHGRID_RADIO_BUTT].flags == D_SELECTED)
    plotparam.gtype = GRID_SMITHGRID;

for (i = 0; i < num_plot; i++)
    Replot(i);

return D_EXIT;
}

int add_trace_ok()
{
wordlist *wtracel;
int ntraceadded;
struct pnode *names,*n;

// Add the new trace to the current trace list
//wl_add(&(curr_dataplot->tracelist),strlwr(trace));
wtracel = cp_parse(strlwr(trace));

names = ft_getpnames(wtracel, false);
free_tracelist(&(wtracel));
for (n = names; n; n = n->pn_next)
    {
    wl_add(&(wtracel),n->pn_name);
    }

ntraceadded = wl_length(wtracel);
curr_dataplot->ntrace += ntraceadded;
curr_dataplot->tracelist = wl_append(curr_dataplot->tracelist,wtracel);
// and plot
Replot(curr_plot);

cursor_menu[0].flags = 0;
trace_dialog[LIST_PROC].d1 = 0;
//curr_dataplot->ntrace++;
return D_EXIT;
}

int remove_trace_ok()
{
if (curr_dataplot->ntrace == 1)
    alert("You can't delete all traces!",NULL,NULL,"OK",NULL,0,0);
else
{
// Remove the trace from trace list
wl_delete(&(curr_dataplot->tracelist),trace);
// and plot
Replot(curr_plot);

trace_dialog[LIST_PROC].d1 = 0;
curr_dataplot->ntrace--;

// Reset cursor trace
if(cursor_enabled)
    get_cursor_init_pos();
}
return D_EXIT;
}

char *add_trace_list(int index, int *list_size)
{
struct dvec *v;
int i = 0;

if (index < 0)
   {
   for (v = plot_cur->pl_dvecs; v; v = v->v_next)
       i++;
   *list_size = i;
   return NULL;
   }
else
   {
   for (v = plot_cur->pl_dvecs; i < index; v = v->v_next)
       i++;
   return v->v_name;
   }
}

char *remove_trace_list(int index, int *list_size)
{
wordlist *wl;
int i = 0;

if (index < 0)
   {
   for (wl = curr_dataplot->tracelist; wl; wl = wl->wl_next)
       i++;
   *list_size = i;
   return NULL;
   }
else
   {
   for (wl = curr_dataplot->tracelist; i < index; wl = wl->wl_next)
       i++;
   return wl->wl_word;
   }
}

int cancel()
{
return D_EXIT;
}

int file_exit()
{
return D_EXIT;
}

int load_rawfile()
{
char path[255];

file_select("Load rawfile...",path,"RAW");
return D_O_K;
}

int about()
{
// Note: the palette used in the logo are the same used
// in the program (pal), so we don't change them before
// blitting the bitmap
about_dialog[TEXT_VERS].dp = ft_sim->version;
about_dialog[LOGO_BMP].dp = datafile[Logo].dat;
centre_dialog(about_dialog);
popup_dialog(about_dialog,OK_BUTT);  // blit the bitmap
return D_O_K;
}

int set_video_mode()
{
screen_type  = GFX_MODEX;
mfbpc_width  = 256;
mfbpc_height = 256;
config.numxpixels = mfbpc_width;
config.numypixels = mfbpc_height - menu_width;
config.numcolors  = 256;
dispdev->width = config.numxpixels + 1;
dispdev->height = config.numypixels + 1;
dispdev->numcolors = config.numcolors - 1;

show_mouse(NULL);
set_gfx_mode(GFX_MODEX,mfbpc_width,mfbpc_height,0,0);
// set_gfx_color changes gui color, so we reset them
gui_fg_color=5;
gui_bg_color=0;
gui_mg_color=8;

set_palette(pal);
show_mouse(screen);

destroy_bitmap(bmp);
destroy_bitmap(bmptmp);
destroy_bitmap(plotsbmp);
bmp = create_bitmap(config.numxpixels, config.numypixels);
bmptmp = create_bitmap(config.numxpixels,config.numypixels);
plotsbmp = create_bitmap(config.numxpixels,config.numypixels);
currbmp = bmp;

clear_to_color(bmp,0);
/*gr_resize(curr_dataplot->graphic);
gr_redraw(curr_dataplot->graphic);
blit(bmp,plotsbmp,0,0,0,config.numypixels * 0,
     config.numxpixels,config.numypixels);*/
Replot(0);
redraw();

return D_O_K;
}

int add_trace()
{
cp_periodic();

// Setting trace dialog (Add)
trace_dialog[TEXT_TITLE].dp = "Add Trace...";
trace_dialog[TRACE_BUTT1].dp2 = add_trace_ok;
trace_dialog[EDIT_PROC].proc = d_edit_proc;
trace_dialog[LIST_PROC].proc = d_my_add_list_proc;
trace_dialog[LIST_PROC].dp = add_trace_list;

centre_dialog(trace_dialog);
popup_dialog(trace_dialog,TRACE_BUTT1);
redraw();
the_dialog[SEL_PLOT].proc(MSG_USER,&the_dialog[SEL_PLOT],0);
return D_O_K;
}

int option()
{
cp_vset("units",VT_STRING,"degree");
Replot(0);
return 0;
}

int remove_trace()
{
cp_periodic();

// Setting trace dialog (Remove)
trace_dialog[TEXT_TITLE].dp = "Remove Trace...";
trace_dialog[TRACE_BUTT1].dp2 = remove_trace_ok;
trace_dialog[EDIT_PROC].proc = d_text_proc;
trace_dialog[LIST_PROC].proc = d_my_rem_list_proc;
trace_dialog[LIST_PROC].dp = remove_trace_list;

centre_dialog(trace_dialog);
popup_dialog(trace_dialog,TRACE_BUTT1);
redraw();
return D_O_K;
}

void check_param()
{
// Initialize x_axis and y_axis radio buttons
if ((plotparam.gtype == GRID_LIN) || (plotparam.gtype == GRID_YLOG))
    {
    x_axis_dialog[LIN_RADIO_BUTT].flags = D_SELECTED;
    x_axis_dialog[LOG_RADIO_BUTT].flags = 0;
    }
else if ((plotparam.gtype == GRID_XLOG) || (plotparam.gtype == GRID_LOGLOG))
    {
    x_axis_dialog[LOG_RADIO_BUTT].flags = D_SELECTED;
    x_axis_dialog[LIN_RADIO_BUTT].flags = 0;
    }

if ((plotparam.gtype == GRID_LIN) || (plotparam.gtype == GRID_XLOG))
    {
    y_axis_dialog[LIN_RADIO_BUTT].flags = D_SELECTED;
    y_axis_dialog[LOG_RADIO_BUTT].flags = 0;
    }
else if ((plotparam.gtype == GRID_YLOG) || (plotparam.gtype == GRID_LOGLOG))
    {
    y_axis_dialog[LOG_RADIO_BUTT].flags = D_SELECTED;
    y_axis_dialog[LIN_RADIO_BUTT].flags = 0;
    }

// Initialize xlo xhi ylo yhi
sprintf(xlo,"%g",plotparam.xlo);
sprintf(xhi,"%g",plotparam.xhi);
sprintf(ylo,"%g",plotparam.ylo);
sprintf(yhi,"%g",plotparam.yhi);
}

void check_analyses()
{
struct plot *pl;

// enable available analyses
for (pl = plot_list; pl; pl = pl->pl_next)
    {
    if (ciprefix("ac",pl->pl_typename))
        plot_menu[SEL_ANALISYS].flags = 0;
    else if (ciprefix("dc",pl->pl_typename))
        plot_menu[SEL_ANALISYS+1].flags = 0;
    else if (ciprefix("tran",pl->pl_typename))
        plot_menu[SEL_ANALISYS+2].flags = 0;
    }

// check mark the current analysis
if (ciprefix("ac",plot_cur->pl_typename))
    plot_menu[SEL_ANALISYS].flags = D_SELECTED;
else if (ciprefix("dc",plot_cur->pl_typename))
    plot_menu[SEL_ANALISYS+1].flags = D_SELECTED;
else if (ciprefix("tran",plot_cur->pl_typename))
    plot_menu[SEL_ANALISYS+2].flags = D_SELECTED;
}

int menu(struct dvec *vecs)
{
char AppName[]="Spice+";
char TitleName[512];
int ret;
wordlist *wltmp;
int i;

if (menu_on == 0)
    {
    num_plot = 1;
    curr_plot = 0;

    first_d = vec_copy(currentgraph->plotdata->vector);
    blit(bmp,plotsbmp,0,0,0,0,config.numxpixels,config.numypixels);
    redraw();
    menu_on = 1;
    for (i=0; i<MAXNUMPLOT; i++)
        {
        dataplot[i].tracelist = NULL;
        dataplot[i].ntrace = 0;
        }

    //dataplot[0].tracelist = wl_copy(wl);
    dataplot[0].tracelist = vec2wl_copy(vecs);
    dataplot[0].graphic = CopyGraph(currentgraph);
    curr_dataplot = &dataplot[0];
    set_plot_param();
    check_param();

    for (wltmp = curr_dataplot->tracelist; wltmp; wltmp = wltmp->wl_next)
        curr_dataplot->ntrace++;

    Set_plot_rect(&(curr_dataplot->rgraph),curr_dataplot->graphic);

    //check_analyses();

    bmptmp = create_bitmap(config.numxpixels,config.numypixels);
    curposbmp = create_bitmap(config.numxpixels/2, curr_dataplot->rgraph.h/7);
    cross_mouse = create_bitmap(11,11);

    clear_to_color(cross_mouse,0);
    hline(cross_mouse, 0, 5, 10, 5);
    vline(cross_mouse, 5, 0, 10, 5);

    // Set the initial mouse pointer
    set_mouse_sprite(NULL);
    gui_mouse_focus = 0;

    strcpy(TitleName, AppName);
    if (ft_circuits)
        if (ft_circuits->ci_name)
            {
            strcat(TitleName, " - ");
            strcat(TitleName, ft_circuits->ci_name);
            }
    set_window_title(TitleName);

    //set_window_close_button(1);
    //set_window_close_hook(close_window);
    cursor_menu[0].text = (char *) malloc(sizeof(char) * (strlen("&Disable") + 1));
    strcpy(cursor_menu[0].text,"&Enable");
    ret = do_dialog(the_dialog,-1);
    free(cursor_menu[0].text);

    destroy_bitmap(cross_mouse);
    destroy_bitmap(curposbmp);
    destroy_bitmap(bmptmp);

    // Reset num_plot to 1
    num_plot = 1;
    config.numypixels = mfbpc_height - menu_width;
    dispdev->height = config.numypixels + 1;
    
    menu_on = 0;
    graph_mode_on = 0;
    }
return 0;
}

#endif
