
ifeq ($(GRAPHICS),allegro)
MFBPC_COBJS     = allegro.o menu.o fixed.o cursor.o
else
ifeq ($(GRAPHICS),gdi)
MFBPC_COBJS     = gdi.o
else
ifeq ($(GRAPHICS),gtk)
MFBPC_COBJS     = gtk.o
endif
endif
endif

ifeq ($(OSTYPE),linux)
ifeq ($(GRAPHICS),gtk)
EXFLAGS        +=`pkg-config --cflags gtk+-2.0`
endif
endif

ifeq ($(OSTYPE),mingw)
ifeq ($(GRAPHICS),gtk)
EXFLAGS        +=-I/mingw/include/gtk-2.0 -I/mingw/include/glib-2.0
endif
endif

MFBPC_COBJS    += cursaux.o plot.o

MFBPC_SRC_DIR   = src/lib/mfbpc
MFBPC_OBJ_DIR   = $(OBJS_DIR)/mfbpc

MFBPC_OBJ       = $(addprefix $(MFBPC_OBJ_DIR)/,$(MFBPC_COBJS))
MFBPC_LIBRARY   = mfbpc
MFBPC_LIB       = $(OBJLIB_DIR)/lib$(MFBPC_LIBRARY).a

mfbpc: $(MFBPC_LIB)

$(MFBPC_LIB): $(MFBPC_OBJ)
	@echo Archiving $@...
	$(AR) rcs $@ $^

$(MFBPC_OBJ_DIR)/%.o: $(MFBPC_SRC_DIR)/%.c
	@echo Compiling $<...
	$(CC) $(FLAGS) $(EXFLAGS) $(DEFS) $(INCLUDE) -c $< -o $@

mfbpc_clean:
	@echo Deleting mfbpc library...
	$(RM) $(MFBPC_LIB)
	$(RM) r $(MFBPC_OBJ)


FRONTEND_LIB = $(OBJLIB_DIR)/libfrontend.a
frontend: $(FRONTEND_LIB)

ifdef DLL
$(FRONTEND_LIB): libfrontend.dll

libfrontend.dll: $(CP_OBJ) $(FTE_OBJ) $(MFBPC_OBJ) $(HLP_OBJ)
	@echo Creating DLL $@...
	$(CC) -shared -o $@ -Wl,--out-implib=$(OBJLIB_DIR)/libfrontend.a $^ \
   -L$(OBJLIB_DIR) -linp -lmisc -lglobal $(EXLIB)

else
ifdef SO
$(FRONTEND_LIB): libfrontend.so

libfrontend.so: $(CP_OBJ) $(FTE_OBJ) $(MFBPC_OBJ) $(HLP_OBJ)
	@echo Creating Shared Library $@...
	$(CC) -shared -o $@ $^ -L. -linp -lmisc -lglobal $(EXLIB)

endif
endif

