
MISC_COBJS = alloc.o dos_dirs.o dup2.o math.o mktemp.o printnum.o \
             string.o tilde.o time.o

MISC_SRC_DIR    = src/lib/misc
MISC_OBJ_DIR    = $(OBJS_DIR)/misc

MISC_OBJ        = $(addprefix $(MISC_OBJ_DIR)/,$(MISC_COBJS))
MISC_LIBRARY    = misc
MISC_LIB        = $(OBJLIB_DIR)/lib$(MISC_LIBRARY).a

misc: $(MISC_LIB)

ifdef DLL
$(MISC_LIB): lib$(MISC_LIBRARY).dll

lib$(MISC_LIBRARY).dll: $(MISC_OBJ) $(BIN_OBJ_DIR)/$(TUNEFILE).o
	@echo Creating DLL $@...
	$(CC) $(FLAGS) -mwindows -shared -o $@ -Wl,--out-implib=$(MISC_LIB) $^ \
   -L$(OBJLIB_DIR) -lglobal

else
ifdef SO
$(MISC_LIB): lib$(MISC_LIBRARY).so

lib$(MISC_LIBRARY).so: $(MISC_OBJ)
	@echo Creating Shared Library $@...
	$(CC) $(FLAGS) -shared -o $@ $^

else
$(MISC_LIB): $(MISC_OBJ)
	@echo Archiving $@...
	$(AR) rcs $@ $^
endif
endif
   
$(MISC_OBJ_DIR)/%.o: $(MISC_SRC_DIR)/%.c
	@echo Compiling $<...
	$(CC) $(FLAGS) $(INCLUDE) -c $< -o $@

misc_clean:
	@echo Deleting misc library...
	$(RM) $(MISC_LIB)
	$(RM) -r $(MISC_OBJ)
      
