
SPARSE_COBJS = spalloc.o spbuild.o spextra.o spfactor.o spoutput.o \
               spsmp.o spsolve.o sputils.o

SPARSE_SRC_DIR  = src/lib/sparse
SPARSE_OBJ_DIR  = $(OBJS_DIR)/sparse

SPARSE_OBJ      = $(addprefix $(SPARSE_OBJ_DIR)/,$(SPARSE_COBJS))
SPARSE_LIBRARY  = sparse
SPARSE_LIB      = $(OBJLIB_DIR)/lib$(SPARSE_LIBRARY).a

sparse: $(SPARSE_LIB)

ifdef DLL
$(SPARSE_LIB): lib$(SPARSE_LIBRARY).dll

lib$(SPARSE_LIBRARY).dll: $(SPARSE_OBJ)
	@echo Creating DLL $@...
	$(CC) $(FLAGS) -shared -o $@ -Wl,--out-implib=$(SPARSE_LIB) $^ \
   -L$(OBJLIB_DIR) -lmisc -lglobal

else
ifdef SO
$(SPARSE_LIB): lib$(SPARSE_LIBRARY).so

lib$(SPARSE_LIBRARY).so: $(SPARSE_OBJ)
	@echo Creating Shared Library $@...
	$(CC) $(FLAGS) -shared -o $@ $^ -L. -lmisc

else
$(SPARSE_LIB): $(SPARSE_OBJ)
	@echo Archiving $@...
	$(AR) rcs $@ $^
endif
endif

$(SPARSE_OBJ_DIR)/%.o: $(SPARSE_SRC_DIR)/%.c
	@echo Compiling $<...
	$(CC) $(FLAGS) $(INCLUDE) -c $< -o $@

sparse_clean:
	@echo Deleting sparse library...
	$(RM) $(SPARSE_LIB)
	$(RM) -r $(SPARSE_OBJ)

